#include <c_decl.h>
#include "sys.h"
#include "lisp.h"

static void Z83_mapcar_internal(CL_FORM *base, CL_FORM *display[]);

void Fmapcar(CL_FORM *base, int nargs)
{
	CL_FORM *display[2];
	Flist(STACK(base, 2), nargs - 2);
	display[0] = STACK(base, 0);
	Z83_mapcar_internal(STACK(base, 3), display);
	COPY(STACK(base, 3), STACK(base, 0));
}

static void Z84_get_rest_args(CL_FORM *base, CL_FORM *display[]);

static void Z83_mapcar_internal(CL_FORM *base, CL_FORM *display[])
{
	CONTENV new_cont;
	CL_FORM *caller_base;
	new_cont.bind_top = bind_top;
	new_cont.last = last_cont;
	LOAD_UNIQUE_TAG(STACK(base, 0));
	caller_base = (CL_FORM *)SETJMP(new_cont.jmp_buf);
	if(caller_base == NULL)
	{
		last_cont = &new_cont;
		if(CL_ATOMP(&display[0][1]))
		{
			LOAD_NIL(STACK(base, 0));
		}
		else
		{
			COPY(&display[0][0], STACK(base, 1));
			COPY(&display[0][1], STACK(base, 2));
			COPY(GET_CAR(STACK(base, 2)), STACK(base, 2));
			COPY(&display[0][1], STACK(base, 3));
			COPY(STACK(base, 3), STACK(base, 4));
			COPY(GET_CAR(STACK(base, 4)) + 1, &display[0][1]);
			COPY(&display[0][2], STACK(base, 3));
			display[1] = STACK(base, 0);
			Z84_get_rest_args(STACK(base, 3), display);
			Fapply(STACK(base, 1), 3);
			mv_count = 1;
			Z83_mapcar_internal(STACK(base, 2), display);
			{
				CL_FORM *lptr;
				lptr = form_alloc(STACK(base, 3), 2);
				COPY(STACK(base, 1), lptr);
				COPY(STACK(base, 2), lptr + 1);
				LOAD_CONS(lptr, STACK(base, 0));
			}
		}
		RETURN56:;
		last_cont = new_cont.last;
	}
	else
	{
		last_cont = new_cont.last;
		if(EQ(STACK(caller_base, 0), STACK(base, 0)))
		{
			COPY(STACK(caller_base, 1), STACK(base, 0));
		}
		else
		{
			call_cont(caller_base);
		}
	}
}

static void Z84_get_rest_args(CL_FORM *base, CL_FORM *display[])
{
	if(CL_ATOMP(STACK(base, 0)))
	{
		LOAD_NIL(STACK(base, 0));
	}
	else
	{
		COPY(GET_CAR(STACK(base, 0)), STACK(base, 1));
		if(CL_ATOMP(STACK(base, 1)))
		{
			COPY(&display[1][0], STACK(base, 1));
			LOAD_NIL(STACK(base, 2));
			call_cont(STACK(base, 1));
		}
		COPY(STACK(base, 0), STACK(base, 1));
		COPY(GET_CAR(STACK(base, 0)), STACK(base, 2));
		COPY(STACK(base, 2), STACK(base, 3));
		if(CL_TRUEP(STACK(base, 3)))
		{
			if(CL_CONSP(STACK(base, 3)))
			{
				COPY(GET_CAR(STACK(base, 3)), STACK(base, 3));
			}
			else
			{
				LOAD_SMSTR((CL_FORM *)&KClisp[62], STACK(base, 4)); /* ~a is not a list */
				COPY(STACK(base, 3), STACK(base, 5));
				Ferror(STACK(base, 4), 2);
			}
		}
		else
		{
		}
		COPY(STACK(base, 2), STACK(base, 4));
		COPY(STACK(base, 4), STACK(base, 5));
		if(CL_TRUEP(STACK(base, 5)))
		{
			if(CL_CONSP(STACK(base, 5)))
			{
				COPY(GET_CAR(STACK(base, 5)) + 1, STACK(base, 2));
			}
			else
			{
				LOAD_SMSTR((CL_FORM *)&KClisp[60], STACK(base, 6)); /* ~a is not a list */
				COPY(STACK(base, 5), STACK(base, 7));
				Ferror(STACK(base, 6), 2);
			}
		}
		else
		{
			LOAD_NIL(STACK(base, 2));
		}
		COPY(STACK(base, 2), STACK(base, 4));
		COPY(STACK(base, 4), GET_FORM(STACK(base, 0)));
		COPY(STACK(base, 3), STACK(base, 1));
		COPY(GET_CAR(STACK(base, 0)) + 1, STACK(base, 2));
		Z84_get_rest_args(STACK(base, 2), display);
		{
			CL_FORM *lptr;
			lptr = form_alloc(STACK(base, 3), 2);
			COPY(STACK(base, 1), lptr);
			COPY(STACK(base, 2), lptr + 1);
			LOAD_CONS(lptr, STACK(base, 0));
		}
	}
}
