#include <c_decl.h>
#include "sys.h"
#include "lisp.h"

GLOBAL_FUNARG CFremove = {Fremove, -3};

void Fremove(CL_FORM *base, int nargs)
{
	BOOL supl_flags[7];
	static CL_FORM * keylist[] =
	{
		SYMBOL(Slisp, 233), /* FROM-END */
		SYMBOL(Slisp, 217), /* TEST */
		SYMBOL(Slisp, 323), /* TEST-NOT */
		SYMBOL(Slisp, 165), /* START */
		SYMBOL(Slisp, 166), /* END */
		SYMBOL(Slisp, 392), /* COUNT */
		SYMBOL(Slisp, 139), /* KEY */
	};
	keysort(STACK(base, 2), nargs - 2, 7, keylist, supl_flags, FALSE);
	if(NOT(supl_flags[0]))
	{
		LOAD_NIL(STACK(base, 2));
	}
	if(NOT(supl_flags[1]))
	{
		LOAD_NIL(STACK(base, 3));
	}
	if(NOT(supl_flags[2]))
	{
		LOAD_NIL(STACK(base, 4));
	}
	if(NOT(supl_flags[3]))
	{
		LOAD_FIXNUM(0, STACK(base, 5));
	}
	if(NOT(supl_flags[4]))
	{
		LOAD_NIL(STACK(base, 6));
	}
	if(NOT(supl_flags[5]))
	{
		LOAD_NIL(STACK(base, 7));
	}
	if(NOT(supl_flags[6]))
	{
		LOAD_GLOBFUN(&CFidentity, STACK(base, 8));
	}
	if(CL_CONSP(STACK(base, 1)) || CL_NILP(STACK(base, 1)))
	{
		COPY(STACK(base, 1), STACK(base, 9));
		raw_list_length(STACK(base, 9));
	}
	else
	{
		if(TYPE_OF(STACK(base, 1)) >= T_VEC_LO && TYPE_OF(STACK(base, 1)) <= T_VEC_HI)
		{
			LOAD_FIXNUM(AR_SIZE(GET_FORM(STACK(base, 1))), STACK(base, 9));
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&KClisp[32], STACK(base, 9)); /* ~a is not a sequence */
			COPY(STACK(base, 1), STACK(base, 10));
			Ferror(STACK(base, 9), 2);
		}
	}
	LOAD_NIL(STACK(base, 10));
	LOAD_NIL(STACK(base, 11));
	LOAD_NIL(STACK(base, 12));
	COPY(STACK(base, 3), STACK(base, 13));
	COPY(STACK(base, 4), STACK(base, 14));
	if(CL_TRUEP(STACK(base, 13)))
	{
		bool_result = CL_TRUEP(STACK(base, 14));
	}
	else
	{
		bool_result = FALSE;
	}
	if(bool_result)
	{
		LOAD_SMSTR((CL_FORM *)&KClisp[36], STACK(base, 15)); /* The TEST argument and the TEST-NOT argument are both set */
		Ferror(STACK(base, 15), 1);
	}
	else
	{
		if(CL_TRUEP(STACK(base, 13)))
		{
			COPY(STACK(base, 13), STACK(base, 3));
		}
		else
		{
			if(CL_TRUEP(STACK(base, 14)))
			{
				COPY(STACK(base, 14), STACK(base, 15));
				Fcomplement(STACK(base, 15));
				COPY(STACK(base, 15), STACK(base, 3));
			}
			else
			{
				static GLOBAL_FUNARG extern_closure = {Feql, 2};
				LOAD_GLOBFUN(&extern_closure, STACK(base, 3));
			}
		}
	}
	COPY(STACK(base, 5), STACK(base, 13));
	COPY(STACK(base, 6), STACK(base, 14));
	COPY(STACK(base, 9), STACK(base, 15));
	check_seq_start_end(STACK(base, 13));
	COPY(STACK(base, 13), STACK(base, 6));
	COPY(STACK(base, 7), STACK(base, 13));
	COPY(STACK(base, 9), STACK(base, 14));
	if(CL_FIXNUMP(STACK(base, 13)))
	{
		COPY(STACK(base, 13), STACK(base, 15));
		Fplusp(STACK(base, 15));
		if(CL_TRUEP(STACK(base, 15)))
		{
			COPY(STACK(base, 13), STACK(base, 7));
		}
		else
		{
			LOAD_FIXNUM(0, STACK(base, 7));
		}
	}
	else
	{
		if(CL_TRUEP(STACK(base, 13)))
		{
			LOAD_SMSTR((CL_FORM *)&KClisp[34], STACK(base, 15)); /* ~S should be an INTEGER at least 0 and no more than 16777214 */
			COPY(STACK(base, 13), STACK(base, 16));
			Ferror(STACK(base, 15), 2);
		}
		else
		{
			COPY(STACK(base, 14), STACK(base, 7));
		}
	}
	COPY(STACK(base, 0), STACK(base, 13));
	COPY(STACK(base, 1), STACK(base, 14));
	COPY(STACK(base, 3), STACK(base, 15));
	COPY(STACK(base, 5), STACK(base, 16));
	COPY(STACK(base, 6), STACK(base, 17));
	COPY(STACK(base, 8), STACK(base, 18));
	matched_items(STACK(base, 13));
	COPY(STACK(base, 13), STACK(base, 10));
	if(CL_CONSP(STACK(base, 13)) || CL_NILP(STACK(base, 13)))
	{
		COPY(STACK(base, 13), STACK(base, 14));
		raw_list_length(STACK(base, 14));
		COPY(STACK(base, 14), STACK(base, 11));
	}
	else
	{
		if(TYPE_OF(STACK(base, 13)) >= T_VEC_LO && TYPE_OF(STACK(base, 13)) <= T_VEC_HI)
		{
			LOAD_FIXNUM(AR_SIZE(GET_FORM(STACK(base, 13))), STACK(base, 11));
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&KClisp[32], STACK(base, 14)); /* ~a is not a sequence */
			COPY(STACK(base, 13), STACK(base, 15));
			Ferror(STACK(base, 14), 2);
		}
	}
	COPY(STACK(base, 1), STACK(base, 13));
	if(CL_CONSP(STACK(base, 13)) || CL_NILP(STACK(base, 13)))
	{
		LOAD_SYMBOL(SYMBOL(Slisp, 28), STACK(base, 13)); /* LIST */
	}
	else
	{
		if(TYPE_OF(STACK(base, 13)) >= T_VEC_LO && TYPE_OF(STACK(base, 13)) <= T_VEC_HI)
		{
			LOAD_SYMBOL(SYMBOL(Slisp, 47), STACK(base, 14)); /* VECTOR */
			COPY(STACK(base, 13), STACK(base, 15));
			array_element_type_internal(STACK(base, 15));
			to_element_type(STACK(base, 15));
			Flist(STACK(base, 14), 2);
			COPY(STACK(base, 14), STACK(base, 13));
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&KClisp[38], STACK(base, 13)); /* Unexpected error */
			Ferror(STACK(base, 13), 1);
		}
	}
	COPY(STACK(base, 9), STACK(base, 14));
	COPY(STACK(base, 11), STACK(base, 15));
	COPY(STACK(base, 7), STACK(base, 16));
	Fmin(STACK(base, 15), 2);
	Fminus(STACK(base, 14), 2);
	Fmake_sequence(STACK(base, 13), 2);
	COPY(STACK(base, 13), STACK(base, 12));
	if(CL_TRUEP(STACK(base, 2)))
	{
		LOAD_FIXNUM(0, STACK(base, 13));
		LOAD_FIXNUM(0, STACK(base, 14));
		M165_1:;
		COPY(STACK(base, 13), STACK(base, 15));
		COPY(STACK(base, 9), STACK(base, 16));
		Fge(STACK(base, 15), 2);
		if(CL_TRUEP(STACK(base, 15)))
		{
			goto RETURN187;
		}
		COPY(STACK(base, 11), STACK(base, 15));
		COPY(STACK(base, 7), STACK(base, 16));
		Fle(STACK(base, 15), 2);
		if(CL_TRUEP(STACK(base, 15)))
		{
			COPY(STACK(base, 10), STACK(base, 15));
			if(CL_TRUEP(STACK(base, 15)))
			{
				if(CL_CONSP(STACK(base, 15)))
				{
					COPY(GET_CAR(STACK(base, 15)), STACK(base, 15));
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&KClisp[62], STACK(base, 16)); /* ~a is not a list */
					COPY(STACK(base, 15), STACK(base, 17));
					Ferror(STACK(base, 16), 2);
				}
			}
			else
			{
				LOAD_NIL(STACK(base, 15));
			}
			bool_result = TYPE_OF(STACK(base, 13)) == TYPE_OF(STACK(base, 15)) && (GET_FORM(STACK(base, 13)) == GET_FORM(STACK(base, 15)) || CL_FLOATP(STACK(base, 13)) && GET_FLOAT(STACK(base, 13)) == GET_FLOAT(STACK(base, 15)));
		}
		else
		{
			bool_result = FALSE;
		}
		if(bool_result)
		{
			COPY(STACK(base, 10), STACK(base, 15));
			if(CL_TRUEP(STACK(base, 15)))
			{
				if(CL_CONSP(STACK(base, 15)))
				{
					COPY(GET_CAR(STACK(base, 15)), STACK(base, 15));
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&KClisp[62], STACK(base, 16)); /* ~a is not a list */
					COPY(STACK(base, 15), STACK(base, 17));
					Ferror(STACK(base, 16), 2);
				}
			}
			else
			{
			}
			COPY(STACK(base, 10), STACK(base, 16));
			COPY(STACK(base, 16), STACK(base, 17));
			if(CL_TRUEP(STACK(base, 17)))
			{
				if(CL_CONSP(STACK(base, 17)))
				{
					COPY(GET_CAR(STACK(base, 17)) + 1, STACK(base, 10));
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&KClisp[60], STACK(base, 18)); /* ~a is not a list */
					COPY(STACK(base, 17), STACK(base, 19));
					Ferror(STACK(base, 18), 2);
				}
			}
			else
			{
				LOAD_NIL(STACK(base, 10));
			}
			COPY(STACK(base, 11), STACK(base, 15));
			F1minus(STACK(base, 15));
			COPY(STACK(base, 15), STACK(base, 11));
		}
		else
		{
			COPY(STACK(base, 12), STACK(base, 15));
			COPY(STACK(base, 14), STACK(base, 16));
			COPY(STACK(base, 1), STACK(base, 17));
			COPY(STACK(base, 13), STACK(base, 18));
			Felt(STACK(base, 17));
			COPY(STACK(base, 17), STACK(base, 18));
			COPY(STACK(base, 15), STACK(base, 19));
			COPY(STACK(base, 16), STACK(base, 20));
			Fset_elt(STACK(base, 18));
			COPY(STACK(base, 14), STACK(base, 15));
			F1plus(STACK(base, 15));
			COPY(STACK(base, 15), STACK(base, 14));
		}
		COPY(STACK(base, 13), STACK(base, 15));
		F1plus(STACK(base, 15));
		COPY(STACK(base, 15), STACK(base, 13));
		goto M165_1;
		RETURN187:;
	}
	else
	{
		LOAD_FIXNUM(0, STACK(base, 13));
		LOAD_FIXNUM(0, STACK(base, 14));
		M166_1:;
		COPY(STACK(base, 13), STACK(base, 15));
		COPY(STACK(base, 9), STACK(base, 16));
		Fge(STACK(base, 15), 2);
		if(CL_TRUEP(STACK(base, 15)))
		{
			goto RETURN188;
		}
		COPY(STACK(base, 7), STACK(base, 15));
		Fplusp(STACK(base, 15));
		if(CL_TRUEP(STACK(base, 15)))
		{
			COPY(STACK(base, 10), STACK(base, 15));
			if(CL_TRUEP(STACK(base, 15)))
			{
				if(CL_CONSP(STACK(base, 15)))
				{
					COPY(GET_CAR(STACK(base, 15)), STACK(base, 15));
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&KClisp[62], STACK(base, 16)); /* ~a is not a list */
					COPY(STACK(base, 15), STACK(base, 17));
					Ferror(STACK(base, 16), 2);
				}
			}
			else
			{
				LOAD_NIL(STACK(base, 15));
			}
			bool_result = TYPE_OF(STACK(base, 13)) == TYPE_OF(STACK(base, 15)) && (GET_FORM(STACK(base, 13)) == GET_FORM(STACK(base, 15)) || CL_FLOATP(STACK(base, 13)) && GET_FLOAT(STACK(base, 13)) == GET_FLOAT(STACK(base, 15)));
		}
		else
		{
			bool_result = FALSE;
		}
		if(bool_result)
		{
			COPY(STACK(base, 10), STACK(base, 15));
			if(CL_TRUEP(STACK(base, 15)))
			{
				if(CL_CONSP(STACK(base, 15)))
				{
					COPY(GET_CAR(STACK(base, 15)), STACK(base, 15));
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&KClisp[62], STACK(base, 16)); /* ~a is not a list */
					COPY(STACK(base, 15), STACK(base, 17));
					Ferror(STACK(base, 16), 2);
				}
			}
			else
			{
			}
			COPY(STACK(base, 10), STACK(base, 16));
			COPY(STACK(base, 16), STACK(base, 17));
			if(CL_TRUEP(STACK(base, 17)))
			{
				if(CL_CONSP(STACK(base, 17)))
				{
					COPY(GET_CAR(STACK(base, 17)) + 1, STACK(base, 10));
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&KClisp[60], STACK(base, 18)); /* ~a is not a list */
					COPY(STACK(base, 17), STACK(base, 19));
					Ferror(STACK(base, 18), 2);
				}
			}
			else
			{
				LOAD_NIL(STACK(base, 10));
			}
			COPY(STACK(base, 7), STACK(base, 15));
			F1minus(STACK(base, 15));
			COPY(STACK(base, 15), STACK(base, 7));
		}
		else
		{
			COPY(STACK(base, 12), STACK(base, 15));
			COPY(STACK(base, 14), STACK(base, 16));
			COPY(STACK(base, 1), STACK(base, 17));
			COPY(STACK(base, 13), STACK(base, 18));
			Felt(STACK(base, 17));
			COPY(STACK(base, 17), STACK(base, 18));
			COPY(STACK(base, 15), STACK(base, 19));
			COPY(STACK(base, 16), STACK(base, 20));
			Fset_elt(STACK(base, 18));
			COPY(STACK(base, 14), STACK(base, 15));
			F1plus(STACK(base, 15));
			COPY(STACK(base, 15), STACK(base, 14));
		}
		COPY(STACK(base, 13), STACK(base, 15));
		F1plus(STACK(base, 15));
		COPY(STACK(base, 15), STACK(base, 13));
		goto M166_1;
		RETURN188:;
	}
	COPY(STACK(base, 12), STACK(base, 0));
}
