#include <c_decl.h>
#include "sys.h"
#include "lisp.h"

static void Z77_sublis_internal(CL_FORM *base, CL_FORM *display[]);

void Fsublis(CL_FORM *base, int nargs)
{
	CL_FORM *display[1];
	BOOL supl_flags[3];
	static CL_FORM * keylist[] =
	{
		SYMBOL(Slisp, 217), /* TEST */
		SYMBOL(Slisp, 323), /* TEST-NOT */
		SYMBOL(Slisp, 139), /* KEY */
	};
	keysort(STACK(base, 2), nargs - 2, 3, keylist, supl_flags, FALSE);
	if(NOT(supl_flags[0]))
	{
		LOAD_NIL(STACK(base, 2));
	}
	if(NOT(supl_flags[1]))
	{
		LOAD_NIL(STACK(base, 3));
	}
	if(NOT(supl_flags[2]))
	{
		LOAD_NIL(STACK(base, 4));
	}
	COPY(STACK(base, 2), STACK(base, 5));
	COPY(STACK(base, 3), STACK(base, 6));
	if(CL_TRUEP(STACK(base, 5)))
	{
		bool_result = CL_TRUEP(STACK(base, 6));
	}
	else
	{
		bool_result = FALSE;
	}
	if(bool_result)
	{
		LOAD_SMSTR((CL_FORM *)&KClisp[36], STACK(base, 7)); /* The TEST argument and the TEST-NOT argument are both set */
		Ferror(STACK(base, 7), 1);
	}
	else
	{
		if(CL_TRUEP(STACK(base, 5)))
		{
			COPY(STACK(base, 5), STACK(base, 2));
		}
		else
		{
			if(CL_TRUEP(STACK(base, 6)))
			{
				COPY(STACK(base, 6), STACK(base, 7));
				Fcomplement(STACK(base, 7));
				COPY(STACK(base, 7), STACK(base, 2));
			}
			else
			{
				static GLOBAL_FUNARG extern_closure = {Feql, 2};
				LOAD_GLOBFUN(&extern_closure, STACK(base, 2));
			}
		}
	}
	COPY(STACK(base, 1), STACK(base, 5));
	display[0] = STACK(base, 0);
	Z77_sublis_internal(STACK(base, 5), display);
	COPY(STACK(base, 5), STACK(base, 0));
}

static void Z77_sublis_internal(CL_FORM *base, CL_FORM *display[])
{
	COPY(STACK(base, 0), STACK(base, 1));
	COPY(&display[0][0], STACK(base, 2));
	LOAD_SYMBOL(SYMBOL(Slisp, 217), STACK(base, 3)); /* TEST */
	COPY(&display[0][2], STACK(base, 4));
	LOAD_SYMBOL(SYMBOL(Slisp, 139), STACK(base, 5)); /* KEY */
	COPY(&display[0][4], STACK(base, 6));
	Fassoc(STACK(base, 1), 6);
	if(CL_TRUEP(STACK(base, 1)))
	{
		if(CL_CONSP(STACK(base, 1)))
		{
			COPY(GET_CAR(STACK(base, 1)) + 1, STACK(base, 0));
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&KClisp[60], STACK(base, 0)); /* ~a is not a list */
			Ferror(STACK(base, 0), 2);
		}
	}
	else
	{
		if(CL_TRUEP(STACK(base, 0)))
		{
			if(CL_CONSP(STACK(base, 0)))
			{
				COPY(GET_CAR(STACK(base, 0)), STACK(base, 2));
			}
			else
			{
				LOAD_SMSTR((CL_FORM *)&KClisp[62], STACK(base, 2)); /* ~a is not a list */
				COPY(STACK(base, 0), STACK(base, 3));
				Ferror(STACK(base, 2), 2);
			}
		}
		else
		{
			COPY(STACK(base, 0), STACK(base, 2));
		}
		if(CL_TRUEP(STACK(base, 0)))
		{
			if(CL_CONSP(STACK(base, 0)))
			{
				COPY(GET_CAR(STACK(base, 0)) + 1, STACK(base, 3));
			}
			else
			{
				LOAD_SMSTR((CL_FORM *)&KClisp[60], STACK(base, 3)); /* ~a is not a list */
				COPY(STACK(base, 0), STACK(base, 4));
				Ferror(STACK(base, 3), 2);
			}
		}
		else
		{
			COPY(STACK(base, 0), STACK(base, 3));
		}
		COPY(STACK(base, 2), STACK(base, 4));
		Z77_sublis_internal(STACK(base, 4), display);
		COPY(STACK(base, 3), STACK(base, 5));
		Z77_sublis_internal(STACK(base, 5), display);
		if(TYPE_OF(STACK(base, 4)) == TYPE_OF(STACK(base, 2)) && (GET_FORM(STACK(base, 4)) == GET_FORM(STACK(base, 2)) || CL_FLOATP(STACK(base, 4)) && GET_FLOAT(STACK(base, 4)) == GET_FLOAT(STACK(base, 2))))
		{
			bool_result = TYPE_OF(STACK(base, 5)) == TYPE_OF(STACK(base, 3)) && (GET_FORM(STACK(base, 5)) == GET_FORM(STACK(base, 3)) || CL_FLOATP(STACK(base, 5)) && GET_FLOAT(STACK(base, 5)) == GET_FLOAT(STACK(base, 3)));
		}
		else
		{
			bool_result = FALSE;
		}
		if(bool_result)
		{
		}
		else
		{
			CL_FORM *lptr;
			lptr = form_alloc(STACK(base, 6), 2);
			COPY(STACK(base, 4), lptr);
			COPY(STACK(base, 5), lptr + 1);
			LOAD_CONS(lptr, STACK(base, 0));
		}
	}
}
