#include <c_decl.h>
#include "sys.h"
#include "lisp.h"

static void Z69_tree_equal_internal(CL_FORM *base, CL_FORM *display[]);

void Ftree_equal(CL_FORM *base, int nargs)
{
	CL_FORM *display[1];
	BOOL supl_flags[2];
	static CL_FORM * keylist[] =
	{
		SYMBOL(Slisp, 217), /* TEST */
		SYMBOL(Slisp, 323), /* TEST-NOT */
	};
	keysort(STACK(base, 2), nargs - 2, 2, keylist, supl_flags, FALSE);
	if(NOT(supl_flags[0]))
	{
		LOAD_NIL(STACK(base, 2));
	}
	if(NOT(supl_flags[1]))
	{
		LOAD_NIL(STACK(base, 3));
	}
	COPY(STACK(base, 2), STACK(base, 4));
	COPY(STACK(base, 3), STACK(base, 5));
	if(CL_TRUEP(STACK(base, 4)))
	{
		bool_result = CL_TRUEP(STACK(base, 5));
	}
	else
	{
		bool_result = FALSE;
	}
	if(bool_result)
	{
		LOAD_SMSTR((CL_FORM *)&KClisp[36], STACK(base, 6)); /* The TEST argument and the TEST-NOT argument are both set */
		Ferror(STACK(base, 6), 1);
	}
	else
	{
		if(CL_TRUEP(STACK(base, 4)))
		{
			COPY(STACK(base, 4), STACK(base, 2));
		}
		else
		{
			if(CL_TRUEP(STACK(base, 5)))
			{
				COPY(STACK(base, 5), STACK(base, 6));
				Fcomplement(STACK(base, 6));
				COPY(STACK(base, 6), STACK(base, 2));
			}
			else
			{
				static GLOBAL_FUNARG extern_closure = {Feql, 2};
				LOAD_GLOBFUN(&extern_closure, STACK(base, 2));
			}
		}
	}
	COPY(STACK(base, 0), STACK(base, 4));
	COPY(STACK(base, 1), STACK(base, 5));
	display[0] = STACK(base, 0);
	Z69_tree_equal_internal(STACK(base, 4), display);
	COPY(STACK(base, 4), STACK(base, 0));
}

static void Z69_tree_equal_internal(CL_FORM *base, CL_FORM *display[])
{
	if(CL_ATOMP(STACK(base, 0)))
	{
		if(CL_ATOMP(STACK(base, 1)))
		{
			COPY(&display[0][2], STACK(base, 2));
			COPY(STACK(base, 0), STACK(base, 3));
			COPY(STACK(base, 1), STACK(base, 4));
			Ffuncall(STACK(base, 2), 3);
			COPY(STACK(base, 2), STACK(base, 0));
		}
		else
		{
			LOAD_NIL(STACK(base, 0));
		}
	}
	else
	{
		if(CL_ATOMP(STACK(base, 1)))
		{
			LOAD_NIL(STACK(base, 0));
		}
		else
		{
			COPY(GET_CAR(STACK(base, 0)), STACK(base, 2));
			COPY(GET_CAR(STACK(base, 1)), STACK(base, 3));
			Z69_tree_equal_internal(STACK(base, 2), display);
			mv_count = 1;
			if(CL_TRUEP(STACK(base, 2)))
			{
				COPY(GET_CAR(STACK(base, 0)) + 1, STACK(base, 2));
				COPY(GET_CAR(STACK(base, 1)) + 1, STACK(base, 3));
				Z69_tree_equal_internal(STACK(base, 2), display);
				COPY(STACK(base, 2), STACK(base, 0));
			}
			else
			{
				LOAD_NIL(STACK(base, 0));
			}
		}
	}
}
