#include <c_decl.h>
#include "sys.h"
#include "lisp.h"

GLOBAL_FUNARG Carray_reader = {array_reader, 3};

CL_INIT Karray_reader[] =
{
{ CL_FIXNUM, 37 }, /* 0 */
{ RT_CHAR_PTR, (long)"Rank argument must be supplied to #~a" },
};

static void Z105_calc_dim(CL_FORM *base);

void array_reader(CL_FORM *base)
{
	if(CL_TRUEP(SYMVAL(Slisp, 429))) /* *READ-SUPPRESS* */
	{
		COPY(STACK(base, 0), STACK(base, 3));
		LOAD_SYMBOL(SYMBOL(Ssys, 1), STACK(base, 4)); /* T */
		LOAD_NIL(STACK(base, 5));
		LOAD_SYMBOL(SYMBOL(Ssys, 1), STACK(base, 6)); /* T */
		Fread(STACK(base, 3), 4);
		LOAD_NIL(STACK(base, 0));
	}
	else
	{
		if(CL_TRUEP(STACK(base, 2)))
		{
			COPY(STACK(base, 0), STACK(base, 3));
			LOAD_SYMBOL(SYMBOL(Ssys, 1), STACK(base, 4)); /* T */
			LOAD_NIL(STACK(base, 5));
			LOAD_SYMBOL(SYMBOL(Ssys, 1), STACK(base, 6)); /* T */
			Fread(STACK(base, 3), 4);
			COPY(STACK(base, 3), STACK(base, 4));
			if(GET_FIXNUM(STACK(base, 2)) == 0 && CL_FIXNUMP(STACK(base, 2)))
			{
				LOAD_NIL(STACK(base, 4));
			}
			else
			{
				if(CL_CONSP(STACK(base, 3)) || CL_NILP(STACK(base, 3)))
				{
					COPY(STACK(base, 3), STACK(base, 5));
					raw_list_length(STACK(base, 5));
				}
				else
				{
					if(TYPE_OF(STACK(base, 3)) >= T_VEC_LO && TYPE_OF(STACK(base, 3)) <= T_VEC_HI)
					{
						LOAD_FIXNUM(AR_SIZE(GET_FORM(STACK(base, 3))), STACK(base, 5));
					}
					else
					{
						LOAD_SMSTR((CL_FORM *)&KClisp[32], STACK(base, 5)); /* ~a is not a sequence */
						COPY(STACK(base, 3), STACK(base, 6));
						Ferror(STACK(base, 5), 2);
					}
				}
				COPY(STACK(base, 2), STACK(base, 6));
				F1minus(STACK(base, 6));
				if(CL_TRUEP(STACK(base, 3)))
				{
					if(CL_CONSP(STACK(base, 3)))
					{
						COPY(GET_CAR(STACK(base, 3)), STACK(base, 7));
					}
					else
					{
						LOAD_SMSTR((CL_FORM *)&KClisp[62], STACK(base, 7)); /* ~a is not a list */
						COPY(STACK(base, 3), STACK(base, 8));
						Ferror(STACK(base, 7), 2);
					}
				}
				else
				{
					COPY(STACK(base, 3), STACK(base, 7));
				}
				Z105_calc_dim(STACK(base, 6));
				{
					CL_FORM *lptr;
					lptr = form_alloc(STACK(base, 7), 2);
					COPY(STACK(base, 5), lptr);
					COPY(STACK(base, 6), lptr + 1);
					LOAD_CONS(lptr, STACK(base, 4));
				}
			}
			LOAD_SYMBOL(SYMBOL(Slisp, 98), STACK(base, 5)); /* INITIAL-CONTENTS */
			COPY(STACK(base, 3), STACK(base, 6));
			Fmake_array(STACK(base, 4), 3);
			COPY(STACK(base, 4), STACK(base, 0));
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&Karray_reader[0], STACK(base, 0)); /* Rank argument must be supplied to #~a */
			Ferror(STACK(base, 0), 2);
		}
	}
}

static void Z105_calc_dim(CL_FORM *base)
{
	if(GET_FIXNUM(STACK(base, 0)) == 0 && CL_FIXNUMP(STACK(base, 0)))
	{
		LOAD_NIL(STACK(base, 0));
	}
	else
	{
		COPY(STACK(base, 1), STACK(base, 2));
		Flength(STACK(base, 2));
		COPY(STACK(base, 0), STACK(base, 3));
		F1minus(STACK(base, 3));
		COPY(STACK(base, 1), STACK(base, 4));
		Fcar(STACK(base, 4));
		Z105_calc_dim(STACK(base, 3));
		{
			CL_FORM *lptr;
			lptr = form_alloc(STACK(base, 4), 2);
			COPY(STACK(base, 2), lptr);
			COPY(STACK(base, 3), lptr + 1);
			LOAD_CONS(lptr, STACK(base, 0));
		}
	}
}
