#include <c_decl.h>
#include "sys.h"
#include "lisp.h"

CL_INIT Kpattern_matches[] =
{
{ CL_FIXNUM, 40 }, /* 0 */
{ RT_CHAR_PTR, (long)"ecase: the value ~a is not a legal value" },
{ CL_FIXNUM, 44 }, /* 2 */
{ RT_CHAR_PTR, (long)"etypecase: the value ~a is not a legal value" },
};

static void Z63_maybe_prepend(CL_FORM *base);
static void Z64_matches(CL_FORM *base, CL_FORM *display[]);

void pattern_matches(CL_FORM *base)
{
	CL_FORM *display[1];
	if(CL_CONSP(STACK(base, 1)) || CL_NILP(STACK(base, 1)))
	{
		COPY(STACK(base, 1), STACK(base, 2));
		raw_list_length(STACK(base, 2));
	}
	else
	{
		if(TYPE_OF(STACK(base, 1)) >= T_VEC_LO && TYPE_OF(STACK(base, 1)) <= T_VEC_HI)
		{
			LOAD_FIXNUM(AR_SIZE(GET_FORM(STACK(base, 1))), STACK(base, 2));
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&KClisp[32], STACK(base, 2)); /* ~a is not a sequence */
			COPY(STACK(base, 1), STACK(base, 3));
			Ferror(STACK(base, 2), 2);
		}
	}
	COPY(STACK(base, 0), STACK(base, 3));
	LOAD_SYMBOL(SYMBOL(Slisp, 185), STACK(base, 4)); /* PATTERN */
	COPY(STACK(base, 0), STACK(base, 5));
	LOAD_SYMBOL(SYMBOL(Slisp, 185), STACK(base, 6)); /* PATTERN */
	struct_typep(STACK(base, 5));
	if(CL_TRUEP(STACK(base, 5)))
	{
	}
	else
	{
		COPY(SYMVAL(Slisp, 409), STACK(base, 5)); /* NO_STRUCT */
		COPY(STACK(base, 0), STACK(base, 6));
		LOAD_SYMBOL(SYMBOL(Slisp, 185), STACK(base, 7)); /* PATTERN */
		Ferror(STACK(base, 5), 3);
	}
	COPY(STACK(base, 0), STACK(base, 3));
	LOAD_FIXNUM(0, STACK(base, 4));
	struct_ref_internal(STACK(base, 3));
	LOAD_FIXNUM(0, STACK(base, 4));
	LOAD_NIL(STACK(base, 5));
	LOAD_NIL(STACK(base, 6));
	LOAD_NIL(STACK(base, 7));
	display[0] = STACK(base, 0);
	Z64_matches(STACK(base, 3), display);
	{
		int i;
		for(i = 0; i < mv_count-1; i++)
		COPY(&mv_buf[i], STACK(base, i + 4));
	}
	{
		int nargs;
		nargs = mv_count;
		mv_count = 1;
		switch(nargs)
		{
			case 0:
			LOAD_NIL(STACK(base, 3));
			case 1:
			LOAD_NIL(STACK(base, 4));
			nargs = 2;
		}
		Flist(STACK(base, 5), nargs - 2);
		COPY(STACK(base, 3), STACK(base, 6));
		COPY(STACK(base, 4), STACK(base, 7));
		Freverse(STACK(base, 7));
		COPY(STACK(base, 6), STACK(base, 0));
		COPY(STACK(base, 7), &mv_buf[0]);
		mv_count = 2;
	}
}

static void Z63_maybe_prepend(CL_FORM *base)
{
	if(CL_TRUEP(STACK(base, 1)))
	{
		COPY(STACK(base, 2), STACK(base, 3));
		raw_list_length(STACK(base, 3));
		COPY(STACK(base, 3), STACK(base, 4));
		Fmake_string(STACK(base, 4), 1);
		COPY(STACK(base, 3), STACK(base, 5));
		LOAD_NIL(STACK(base, 6));
		COPY(STACK(base, 2), STACK(base, 7));
		M16_1:;
		if(CL_ATOMP(STACK(base, 7)))
		{
			LOAD_NIL(STACK(base, 6));
			goto RETURN17;
		}
		COPY(STACK(base, 7), STACK(base, 8));
		COPY(GET_CAR(STACK(base, 8)), STACK(base, 6));
		COPY(STACK(base, 5), STACK(base, 8));
		F1minus(STACK(base, 8));
		COPY(STACK(base, 8), STACK(base, 5));
		COPY(STACK(base, 6), STACK(base, 9));
		COPY(STACK(base, 9), STACK(base, 10));
		COPY(STACK(base, 4), STACK(base, 11));
		COPY(STACK(base, 8), STACK(base, 12));
		Fset_schar(STACK(base, 10));
		COPY(STACK(base, 7), STACK(base, 8));
		COPY(GET_CAR(STACK(base, 8)) + 1, STACK(base, 7));
		goto M16_1;
		RETURN17:;
		{
			CL_FORM *lptr;
			lptr = form_alloc(STACK(base, 6), 2);
			COPY(STACK(base, 4), lptr);
			COPY(STACK(base, 0), lptr + 1);
			LOAD_CONS(lptr, STACK(base, 0));
		}
	}
	else
	{
	}
}

static void Z64_matches(CL_FORM *base, CL_FORM *display[])
{
	if(CL_TRUEP(STACK(base, 0)))
	{
		if(CL_CONSP(STACK(base, 0)))
		{
			COPY(GET_CAR(STACK(base, 0)), STACK(base, 5));
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&KClisp[62], STACK(base, 5)); /* ~a is not a list */
			COPY(STACK(base, 0), STACK(base, 6));
			Ferror(STACK(base, 5), 2);
		}
		if(TYPE_OF(STACK(base, 5)) >= T_SMAR_LO && TYPE_OF(STACK(base, 5)) <= T_SMAR_HI)
		{
			COPY(STACK(base, 5), STACK(base, 6));
			LOAD_SYMBOL(SYMBOL(Slisp, 43), STACK(base, 7)); /* STANDARD-CHAR */
			LOAD_SYMBOL(SYMBOL(Slisp, 48), STACK(base, 8)); /* * */
			check_array_internal(STACK(base, 6));
			bool_result = CL_TRUEP(STACK(base, 6));
		}
		else
		{
			bool_result = FALSE;
		}
		if(bool_result)
		{
			COPY(STACK(base, 1), STACK(base, 6));
			if(CL_CONSP(STACK(base, 5)) || CL_NILP(STACK(base, 5)))
			{
				COPY(STACK(base, 5), STACK(base, 7));
				raw_list_length(STACK(base, 7));
			}
			else
			{
				if(TYPE_OF(STACK(base, 5)) >= T_VEC_LO && TYPE_OF(STACK(base, 5)) <= T_VEC_HI)
				{
					LOAD_FIXNUM(AR_SIZE(GET_FORM(STACK(base, 5))), STACK(base, 7));
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&KClisp[32], STACK(base, 7)); /* ~a is not a sequence */
					COPY(STACK(base, 5), STACK(base, 8));
					Ferror(STACK(base, 7), 2);
				}
			}
			Fplus(STACK(base, 6), 2);
			COPY(STACK(base, 6), STACK(base, 7));
			COPY(&display[0][2], STACK(base, 8));
			Fle(STACK(base, 7), 2);
			if(CL_TRUEP(STACK(base, 7)))
			{
				COPY(STACK(base, 5), STACK(base, 7));
				COPY(&display[0][1], STACK(base, 8));
				LOAD_SYMBOL(SYMBOL(Slisp, 215), STACK(base, 9)); /* START2 */
				COPY(STACK(base, 1), STACK(base, 10));
				LOAD_SYMBOL(SYMBOL(Slisp, 216), STACK(base, 11)); /* END2 */
				COPY(STACK(base, 6), STACK(base, 12));
				FstringE(STACK(base, 7), 6);
				if(CL_TRUEP(STACK(base, 7)))
				{
					if(CL_CONSP(STACK(base, 0)))
					{
						COPY(GET_CAR(STACK(base, 0)) + 1, STACK(base, 7));
					}
					else
					{
						LOAD_SMSTR((CL_FORM *)&KClisp[60], STACK(base, 7)); /* ~a is not a list */
						COPY(STACK(base, 0), STACK(base, 8));
						Ferror(STACK(base, 7), 2);
					}
					COPY(STACK(base, 6), STACK(base, 8));
					COPY(STACK(base, 2), STACK(base, 9));
					COPY(STACK(base, 3), STACK(base, 10));
					COPY(STACK(base, 4), STACK(base, 11));
					Z63_maybe_prepend(STACK(base, 9));
					LOAD_NIL(STACK(base, 10));
					LOAD_NIL(STACK(base, 11));
					Z64_matches(STACK(base, 7), display);
					COPY(STACK(base, 7), STACK(base, 0));
				}
				else
				{
					LOAD_NIL(STACK(base, 0));
				}
			}
			else
			{
				LOAD_NIL(STACK(base, 0));
			}
		}
		else
		{
			if(CL_CONSP(STACK(base, 5)) || CL_NILP(STACK(base, 5)))
			{
				if(CL_TRUEP(STACK(base, 5)))
				{
					if(CL_CONSP(STACK(base, 5)))
					{
						COPY(GET_CAR(STACK(base, 5)), STACK(base, 6));
					}
					else
					{
						LOAD_SMSTR((CL_FORM *)&KClisp[62], STACK(base, 6)); /* ~a is not a list */
						COPY(STACK(base, 5), STACK(base, 7));
						Ferror(STACK(base, 6), 2);
					}
				}
				else
				{
					COPY(STACK(base, 5), STACK(base, 6));
				}
				if(GET_SYMBOL(STACK(base, 6)) == SYMBOL(Slisp, 200) && CL_SYMBOLP(STACK(base, 6))) /* CHARACTER-SET */
				{
					COPY(STACK(base, 1), STACK(base, 7));
					COPY(&display[0][2], STACK(base, 8));
					Flt(STACK(base, 7), 2);
					if(CL_TRUEP(STACK(base, 7)))
					{
						COPY(&display[0][1], STACK(base, 7));
						COPY(STACK(base, 1), STACK(base, 8));
						Fschar(STACK(base, 7));
						COPY(STACK(base, 7), STACK(base, 8));
						if(CL_TRUEP(STACK(base, 5)))
						{
							if(CL_CONSP(STACK(base, 5)))
							{
								COPY(GET_CAR(STACK(base, 5)) + 1, STACK(base, 9));
							}
							else
							{
								LOAD_SMSTR((CL_FORM *)&KClisp[60], STACK(base, 9)); /* ~a is not a list */
								COPY(STACK(base, 5), STACK(base, 10));
								Ferror(STACK(base, 9), 2);
							}
						}
						else
						{
							COPY(STACK(base, 5), STACK(base, 9));
						}
						LOAD_SYMBOL(SYMBOL(Slisp, 217), STACK(base, 10)); /* TEST */
						{
							static GLOBAL_FUNARG extern_closure = {FcharE, -2};
							LOAD_GLOBFUN(&extern_closure, STACK(base, 11));
						}
						Ffind(STACK(base, 8), 4);
						if(CL_TRUEP(STACK(base, 8)))
						{
							if(CL_CONSP(STACK(base, 0)))
							{
								COPY(GET_CAR(STACK(base, 0)) + 1, STACK(base, 8));
							}
							else
							{
								LOAD_SMSTR((CL_FORM *)&KClisp[60], STACK(base, 8)); /* ~a is not a list */
								COPY(STACK(base, 0), STACK(base, 9));
								Ferror(STACK(base, 8), 2);
							}
							COPY(STACK(base, 1), STACK(base, 9));
							F1plus(STACK(base, 9));
							COPY(STACK(base, 2), STACK(base, 10));
							LOAD_SYMBOL(SYMBOL(Ssys, 1), STACK(base, 11)); /* T */
							{
								CL_FORM *lptr;
								lptr = form_alloc(STACK(base, 12), 2);
								COPY(STACK(base, 7), lptr);
								COPY(STACK(base, 4), lptr + 1);
								LOAD_CONS(lptr, STACK(base, 12));
							}
							Z64_matches(STACK(base, 8), display);
							COPY(STACK(base, 8), STACK(base, 0));
						}
						else
						{
							LOAD_NIL(STACK(base, 0));
						}
					}
					else
					{
						LOAD_NIL(STACK(base, 0));
					}
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&Kpattern_matches[0], STACK(base, 0)); /* ecase: the value ~a is not a legal value */
					COPY(STACK(base, 6), STACK(base, 1));
					Ferror(STACK(base, 0), 2);
				}
			}
			else
			{
				if(GET_SYMBOL(STACK(base, 5)) == SYMBOL(Slisp, 218) && CL_SYMBOLP(STACK(base, 5))) /* SINGLE-CHAR-WILD */
				{
					COPY(STACK(base, 1), STACK(base, 6));
					COPY(&display[0][2], STACK(base, 7));
					Flt(STACK(base, 6), 2);
					if(CL_TRUEP(STACK(base, 6)))
					{
						if(CL_CONSP(STACK(base, 0)))
						{
							COPY(GET_CAR(STACK(base, 0)) + 1, STACK(base, 6));
						}
						else
						{
							LOAD_SMSTR((CL_FORM *)&KClisp[60], STACK(base, 6)); /* ~a is not a list */
							COPY(STACK(base, 0), STACK(base, 7));
							Ferror(STACK(base, 6), 2);
						}
						COPY(STACK(base, 1), STACK(base, 7));
						F1plus(STACK(base, 7));
						COPY(STACK(base, 2), STACK(base, 8));
						LOAD_SYMBOL(SYMBOL(Ssys, 1), STACK(base, 9)); /* T */
						COPY(&display[0][1], STACK(base, 10));
						COPY(STACK(base, 1), STACK(base, 11));
						Fschar(STACK(base, 10));
						{
							CL_FORM *lptr;
							lptr = form_alloc(STACK(base, 11), 2);
							COPY(STACK(base, 10), lptr);
							COPY(STACK(base, 4), lptr + 1);
							LOAD_CONS(lptr, STACK(base, 10));
						}
						Z64_matches(STACK(base, 6), display);
						COPY(STACK(base, 6), STACK(base, 0));
					}
					else
					{
						LOAD_NIL(STACK(base, 0));
					}
				}
				else
				{
					if(GET_SYMBOL(STACK(base, 5)) == SYMBOL(Slisp, 207) && CL_SYMBOLP(STACK(base, 5))) /* MULTI-CHAR-WILD */
					{
						if(CL_CONSP(STACK(base, 0)))
						{
							COPY(GET_CAR(STACK(base, 0)) + 1, STACK(base, 6));
						}
						else
						{
							LOAD_SMSTR((CL_FORM *)&KClisp[60], STACK(base, 6)); /* ~a is not a list */
							COPY(STACK(base, 0), STACK(base, 7));
							Ferror(STACK(base, 6), 2);
						}
						COPY(STACK(base, 1), STACK(base, 7));
						COPY(STACK(base, 2), STACK(base, 8));
						LOAD_SYMBOL(SYMBOL(Ssys, 1), STACK(base, 9)); /* T */
						COPY(STACK(base, 4), STACK(base, 10));
						Z64_matches(STACK(base, 6), display);
						{
							int i;
							for(i = 0; i < mv_count-1; i++)
							COPY(&mv_buf[i], STACK(base, i + 7));
						}
						{
							int nargs;
							nargs = mv_count;
							mv_count = 1;
							switch(nargs)
							{
								case 0:
								LOAD_NIL(STACK(base, 6));
								case 1:
								LOAD_NIL(STACK(base, 7));
								nargs = 2;
							}
							Flist(STACK(base, 8), nargs - 2);
							if(CL_TRUEP(STACK(base, 6)))
							{
								LOAD_SYMBOL(SYMBOL(Ssys, 1), STACK(base, 9)); /* T */
								COPY(STACK(base, 7), STACK(base, 10));
								COPY(STACK(base, 9), STACK(base, 0));
								COPY(STACK(base, 10), &mv_buf[0]);
								mv_count = 2;
							}
							else
							{
								COPY(STACK(base, 1), STACK(base, 9));
								COPY(&display[0][2], STACK(base, 10));
								Flt(STACK(base, 9), 2);
								if(CL_TRUEP(STACK(base, 9)))
								{
									COPY(STACK(base, 0), STACK(base, 9));
									COPY(STACK(base, 1), STACK(base, 10));
									F1plus(STACK(base, 10));
									COPY(STACK(base, 2), STACK(base, 11));
									LOAD_SYMBOL(SYMBOL(Ssys, 1), STACK(base, 12)); /* T */
									COPY(&display[0][1], STACK(base, 13));
									COPY(STACK(base, 1), STACK(base, 14));
									Fschar(STACK(base, 13));
									{
										CL_FORM *lptr;
										lptr = form_alloc(STACK(base, 14), 2);
										COPY(STACK(base, 13), lptr);
										COPY(STACK(base, 4), lptr + 1);
										LOAD_CONS(lptr, STACK(base, 13));
									}
									Z64_matches(STACK(base, 9), display);
									COPY(STACK(base, 9), STACK(base, 0));
								}
								else
								{
									LOAD_NIL(STACK(base, 0));
								}
							}
						}
					}
					else
					{
						LOAD_SMSTR((CL_FORM *)&Kpattern_matches[2], STACK(base, 0)); /* etypecase: the value ~a is not a legal value */
						COPY(STACK(base, 5), STACK(base, 1));
						Ferror(STACK(base, 0), 2);
					}
				}
			}
		}
	}
	else
	{
		COPY(STACK(base, 1), STACK(base, 5));
		COPY(&display[0][2], STACK(base, 6));
		Fnumeql(STACK(base, 5), 2);
		if(CL_TRUEP(STACK(base, 5)))
		{
			LOAD_SYMBOL(SYMBOL(Ssys, 1), STACK(base, 5)); /* T */
			COPY(STACK(base, 2), STACK(base, 6));
			COPY(STACK(base, 3), STACK(base, 7));
			COPY(STACK(base, 4), STACK(base, 8));
			Z63_maybe_prepend(STACK(base, 6));
			COPY(STACK(base, 5), STACK(base, 0));
			COPY(STACK(base, 6), &mv_buf[0]);
			mv_count = 2;
		}
		else
		{
			LOAD_NIL(STACK(base, 5));
			LOAD_NIL(STACK(base, 6));
			COPY(STACK(base, 5), STACK(base, 0));
			COPY(STACK(base, 6), &mv_buf[0]);
			mv_count = 2;
		}
	}
}
