#include <c_decl.h>
#include "sys.h"
#include "lisp.h"

GLOBAL_FUNARG Cparse_unix_namestring = {parse_unix_namestring, 3};

CL_INIT Kparse_unix_namestring[] =
{
{ CL_FIXNUM, 28 }, /* 0 */
{ RT_CHAR_PTR, (long)"search lists not implemented" },
{ CL_FIXNUM, 2 }, /* 2 */
{ RT_CHAR_PTR, (long)".." },
};

void parse_unix_namestring(CL_FORM *base)
{
	COPY(STACK(base, 0), STACK(base, 3));
	COPY(STACK(base, 1), STACK(base, 4));
	COPY(STACK(base, 2), STACK(base, 5));
	split_at_slashes(STACK(base, 3));
	COPY(&mv_buf[0], STACK(base, 4));
	{
		int nargs;
		nargs = 2;
		mv_count = 1;
		switch(nargs)
		{
			case 0:
			LOAD_NIL(STACK(base, 3));
			case 1:
			LOAD_NIL(STACK(base, 4));
			nargs = 2;
		}
		Flist(STACK(base, 5), nargs - 2);
		if(CL_TRUEP(STACK(base, 3)))
		{
			LOAD_NIL(STACK(base, 6));
		}
		else
		{
			COPY(STACK(base, 4), STACK(base, 6));
			if(CL_TRUEP(STACK(base, 6)))
			{
				if(CL_CONSP(STACK(base, 6)))
				{
					COPY(GET_CAR(STACK(base, 6)), STACK(base, 6));
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&KClisp[62], STACK(base, 7)); /* ~a is not a list */
					COPY(STACK(base, 6), STACK(base, 8));
					Ferror(STACK(base, 7), 2);
				}
			}
			else
			{
				LOAD_NIL(STACK(base, 6));
			}
			COPY(STACK(base, 0), STACK(base, 7));
			if(CL_TRUEP(STACK(base, 6)))
			{
				if(CL_CONSP(STACK(base, 6)))
				{
					COPY(GET_CAR(STACK(base, 6)), STACK(base, 8));
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&KClisp[62], STACK(base, 8)); /* ~a is not a list */
					COPY(STACK(base, 6), STACK(base, 9));
					Ferror(STACK(base, 8), 2);
				}
			}
			else
			{
				COPY(STACK(base, 6), STACK(base, 8));
			}
			if(CL_TRUEP(STACK(base, 6)))
			{
				if(CL_CONSP(STACK(base, 6)))
				{
					COPY(GET_CAR(STACK(base, 6)) + 1, STACK(base, 9));
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&KClisp[60], STACK(base, 9)); /* ~a is not a list */
					COPY(STACK(base, 6), STACK(base, 10));
					Ferror(STACK(base, 9), 2);
				}
			}
			else
			{
				COPY(STACK(base, 6), STACK(base, 9));
			}
			maybe_extract_search_list(STACK(base, 7));
			COPY(&mv_buf[0], STACK(base, 8));
			{
				int nargs;
				nargs = 2;
				mv_count = 1;
				switch(nargs)
				{
					case 0:
					LOAD_NIL(STACK(base, 7));
					case 1:
					LOAD_NIL(STACK(base, 8));
					nargs = 2;
				}
				Flist(STACK(base, 9), nargs - 2);
				if(CL_TRUEP(STACK(base, 7)))
				{
					LOAD_SYMBOL(SYMBOL(Ssys, 1), STACK(base, 3)); /* T */
					COPY(STACK(base, 6), STACK(base, 10));
					COPY(STACK(base, 8), STACK(base, 11));
					if(CL_CONSP(STACK(base, 6)))
					{
						COPY(STACK(base, 8), GET_FORM(STACK(base, 6)));
					}
					else
					{
						LOAD_SMSTR((CL_FORM *)&KClisp[58], STACK(base, 12)); /* ~a is not a cons */
						COPY(STACK(base, 6), STACK(base, 13));
						Ferror(STACK(base, 12), 2);
					}
				}
				COPY(STACK(base, 7), STACK(base, 6));
			}
		}
		COPY(STACK(base, 4), STACK(base, 7));
		Flast(STACK(base, 7), 1);
		if(CL_TRUEP(STACK(base, 7)))
		{
			if(CL_CONSP(STACK(base, 7)))
			{
				COPY(GET_CAR(STACK(base, 7)), STACK(base, 7));
			}
			else
			{
				LOAD_SMSTR((CL_FORM *)&KClisp[62], STACK(base, 8)); /* ~a is not a list */
				COPY(STACK(base, 7), STACK(base, 9));
				Ferror(STACK(base, 8), 2);
			}
		}
		else
		{
			LOAD_NIL(STACK(base, 7));
		}
		if(CL_TRUEP(STACK(base, 7)))
		{
			if(CL_CONSP(STACK(base, 7)))
			{
				COPY(GET_CAR(STACK(base, 7)), STACK(base, 8));
			}
			else
			{
				LOAD_SMSTR((CL_FORM *)&KClisp[62], STACK(base, 8)); /* ~a is not a list */
				COPY(STACK(base, 7), STACK(base, 9));
				Ferror(STACK(base, 8), 2);
			}
		}
		else
		{
			COPY(STACK(base, 7), STACK(base, 8));
		}
		if(CL_TRUEP(STACK(base, 7)))
		{
			if(CL_CONSP(STACK(base, 7)))
			{
				COPY(GET_CAR(STACK(base, 7)) + 1, STACK(base, 9));
			}
			else
			{
				LOAD_SMSTR((CL_FORM *)&KClisp[60], STACK(base, 9)); /* ~a is not a list */
				COPY(STACK(base, 7), STACK(base, 10));
				Ferror(STACK(base, 9), 2);
			}
		}
		else
		{
			COPY(STACK(base, 7), STACK(base, 9));
		}
		COPY(STACK(base, 8), STACK(base, 10));
		COPY(STACK(base, 9), STACK(base, 11));
		Fnumeql(STACK(base, 10), 2);
		if(CL_TRUEP(STACK(base, 10)))
		{
			LOAD_NIL(STACK(base, 7));
		}
		else
		{
			COPY(STACK(base, 4), STACK(base, 10));
			Fbutlast(STACK(base, 10), 1);
			COPY(STACK(base, 10), STACK(base, 4));
			COPY(STACK(base, 0), STACK(base, 7));
			extract_name_type_and_version(STACK(base, 7));
		}
		{
			int i;
			for(i = 0; i < mv_count-1; i++)
			COPY(&mv_buf[i], STACK(base, i + 8));
		}
		{
			int nargs;
			nargs = mv_count;
			mv_count = 1;
			switch(nargs)
			{
				case 0:
				LOAD_NIL(STACK(base, 7));
				case 1:
				LOAD_NIL(STACK(base, 8));
				case 2:
				LOAD_NIL(STACK(base, 9));
				nargs = 3;
			}
			Flist(STACK(base, 10), nargs - 3);
			LOAD_NIL(STACK(base, 11));
			LOAD_NIL(STACK(base, 12));
			LOAD_NIL(STACK(base, 13));
			LOAD_NIL(STACK(base, 14));
			{
				CL_FORM *lptr;
				lptr = form_alloc(STACK(base, 15), 2);
				COPY(STACK(base, 13), lptr);
				COPY(STACK(base, 14), lptr + 1);
				LOAD_CONS(lptr, STACK(base, 13));
			}
			if(CL_TRUEP(STACK(base, 6)))
			{
				LOAD_SMSTR((CL_FORM *)&Kparse_unix_namestring[0], STACK(base, 14)); /* search lists not implemented */
				Ferror(STACK(base, 14), 1);
			}
			LOAD_NIL(STACK(base, 14));
			COPY(STACK(base, 4), STACK(base, 15));
			M22_1:;
			if(CL_ATOMP(STACK(base, 15)))
			{
				LOAD_NIL(STACK(base, 14));
				goto RETURN23;
			}
			COPY(STACK(base, 15), STACK(base, 16));
			COPY(GET_CAR(STACK(base, 16)), STACK(base, 14));
			COPY(STACK(base, 14), STACK(base, 16));
			if(CL_TRUEP(STACK(base, 16)))
			{
				if(CL_CONSP(STACK(base, 16)))
				{
					COPY(GET_CAR(STACK(base, 16)), STACK(base, 16));
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&KClisp[62], STACK(base, 17)); /* ~a is not a list */
					COPY(STACK(base, 16), STACK(base, 18));
					Ferror(STACK(base, 17), 2);
				}
			}
			else
			{
				LOAD_NIL(STACK(base, 16));
			}
			COPY(STACK(base, 14), STACK(base, 17));
			if(CL_TRUEP(STACK(base, 17)))
			{
				if(CL_CONSP(STACK(base, 17)))
				{
					COPY(GET_CAR(STACK(base, 17)) + 1, STACK(base, 17));
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&KClisp[60], STACK(base, 18)); /* ~a is not a list */
					COPY(STACK(base, 17), STACK(base, 19));
					Ferror(STACK(base, 18), 2);
				}
			}
			else
			{
				LOAD_NIL(STACK(base, 17));
			}
			COPY(STACK(base, 16), STACK(base, 18));
			COPY(STACK(base, 17), STACK(base, 19));
			Fnumeql(STACK(base, 18), 2);
			if(CL_TRUEP(STACK(base, 18)))
			{
			}
			else
			{
				COPY(STACK(base, 0), STACK(base, 18));
				COPY(STACK(base, 16), STACK(base, 19));
				COPY(STACK(base, 17), STACK(base, 20));
				maybe_make_pattern(STACK(base, 18));
				if(CL_SMSTRP(STACK(base, 18)))
				{
					COPY(STACK(base, 18), STACK(base, 19));
					LOAD_SMSTR((CL_FORM *)&Kparse_unix_namestring[2], STACK(base, 20)); /* .. */
					FstringE(STACK(base, 19), 2);
					bool_result = CL_TRUEP(STACK(base, 19));
				}
				else
				{
					bool_result = FALSE;
				}
				if(bool_result)
				{
					LOAD_SYMBOL(SYMBOL(Slisp, 209), STACK(base, 19)); /* UP */
					COPY(STACK(base, 13), STACK(base, 20));
					add_q(STACK(base, 19));
				}
				else
				{
					COPY(STACK(base, 18), STACK(base, 19));
					COPY(STACK(base, 13), STACK(base, 20));
					add_q(STACK(base, 19));
				}
			}
			COPY(STACK(base, 15), STACK(base, 16));
			COPY(GET_CAR(STACK(base, 16)) + 1, STACK(base, 15));
			goto M22_1;
			RETURN23:;
			COPY(STACK(base, 13), STACK(base, 14));
			COPY(STACK(base, 14), STACK(base, 15));
			COPY(GET_CAR(STACK(base, 15)), STACK(base, 13));
			if(CL_TRUEP(STACK(base, 3)))
			{
				LOAD_SYMBOL(SYMBOL(Slisp, 202), STACK(base, 14)); /* ABSOLUTE */
				{
					CL_FORM *lptr;
					lptr = form_alloc(STACK(base, 15), 2);
					COPY(STACK(base, 14), lptr);
					COPY(STACK(base, 13), lptr + 1);
					LOAD_CONS(lptr, STACK(base, 13));
				}
			}
			else
			{
				if(CL_TRUEP(STACK(base, 13)))
				{
					LOAD_SYMBOL(SYMBOL(Slisp, 205), STACK(base, 14)); /* RELATIVE */
					{
						CL_FORM *lptr;
						lptr = form_alloc(STACK(base, 15), 2);
						COPY(STACK(base, 14), lptr);
						COPY(STACK(base, 13), lptr + 1);
						LOAD_CONS(lptr, STACK(base, 13));
					}
				}
				else
				{
					LOAD_NIL(STACK(base, 13));
				}
			}
			COPY(STACK(base, 7), STACK(base, 14));
			COPY(STACK(base, 8), STACK(base, 15));
			COPY(STACK(base, 9), STACK(base, 16));
			COPY(STACK(base, 11), STACK(base, 0));
			COPY(STACK(base, 12), &mv_buf[0]);
			COPY(STACK(base, 13), &mv_buf[1]);
			COPY(STACK(base, 14), &mv_buf[2]);
			COPY(STACK(base, 15), &mv_buf[3]);
			COPY(STACK(base, 16), &mv_buf[4]);
			mv_count = 6;
		}
	}
}
