#include <c_decl.h>
#include "sys.h"
#include "lisp.h"

CL_INIT Kunparse_unix_directory_list[] =
{
{ CL_FIXNUM, 1 }, /* 0 */
{ RT_CHAR_PTR, (long)"/" },
{ CL_FIXNUM, 40 }, /* 2 */
{ RT_CHAR_PTR, (long)"ecase: the value ~a is not a legal value" },
{ CL_FIXNUM, 3 }, /* 4 */
{ RT_CHAR_PTR, (long)"../" },
{ CL_FIXNUM, 43 }, /* 6 */
{ RT_CHAR_PTR, (long)":BACK cannot be represented in namestrings." },
{ CL_FIXNUM, 1 }, /* 8 */
{ RT_CHAR_PTR, (long)"/" },
{ CL_FIXNUM, 31 }, /* 10 */
{ RT_CHAR_PTR, (long)"Invalid directory component: ~S" },
};

void unparse_unix_directory_list(CL_FORM *base)
{
	LOAD_NIL(STACK(base, 1));
	LOAD_NIL(STACK(base, 2));
	{
		CL_FORM *lptr;
		lptr = form_alloc(STACK(base, 3), 2);
		COPY(STACK(base, 1), lptr);
		COPY(STACK(base, 2), lptr + 1);
		LOAD_CONS(lptr, STACK(base, 1));
	}
	if(CL_TRUEP(STACK(base, 0)))
	{
		COPY(STACK(base, 0), STACK(base, 2));
		if(CL_CONSP(STACK(base, 2)))
		{
			COPY(GET_CAR(STACK(base, 2)), STACK(base, 2));
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&KClisp[62], STACK(base, 3)); /* ~a is not a list */
			COPY(STACK(base, 2), STACK(base, 4));
			Ferror(STACK(base, 3), 2);
		}
		COPY(STACK(base, 0), STACK(base, 3));
		COPY(STACK(base, 3), STACK(base, 4));
		if(CL_CONSP(STACK(base, 4)))
		{
			COPY(GET_CAR(STACK(base, 4)) + 1, STACK(base, 0));
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&KClisp[60], STACK(base, 5)); /* ~a is not a list */
			COPY(STACK(base, 4), STACK(base, 6));
			Ferror(STACK(base, 5), 2);
		}
		if(GET_SYMBOL(STACK(base, 2)) == SYMBOL(Slisp, 202) && CL_SYMBOLP(STACK(base, 2))) /* ABSOLUTE */
		{
			LOAD_SMSTR((CL_FORM *)&Kunparse_unix_directory_list[0], STACK(base, 3)); /* / */
			COPY(STACK(base, 1), STACK(base, 4));
			add_q(STACK(base, 3));
		}
		else
		{
			if(GET_SYMBOL(STACK(base, 2)) == SYMBOL(Slisp, 205) && CL_SYMBOLP(STACK(base, 2))) /* RELATIVE */
			{
				LOAD_T(STACK(base, 3));
			}
			else
			{
				LOAD_NIL(STACK(base, 3));
			}
			if(CL_TRUEP(STACK(base, 3)))
			{
			}
			else
			{
				LOAD_SMSTR((CL_FORM *)&Kunparse_unix_directory_list[2], STACK(base, 4)); /* ecase: the value ~a is not a legal value */
				COPY(STACK(base, 2), STACK(base, 5));
				Ferror(STACK(base, 4), 2);
			}
		}
		LOAD_NIL(STACK(base, 2));
		COPY(STACK(base, 0), STACK(base, 3));
		M26_1:;
		if(CL_ATOMP(STACK(base, 3)))
		{
			LOAD_NIL(STACK(base, 2));
			goto RETURN27;
		}
		COPY(STACK(base, 3), STACK(base, 4));
		COPY(GET_CAR(STACK(base, 4)), STACK(base, 2));
		if(GET_SYMBOL(STACK(base, 2)) == SYMBOL(Slisp, 209) && CL_SYMBOLP(STACK(base, 2))) /* UP */
		{
			LOAD_SMSTR((CL_FORM *)&Kunparse_unix_directory_list[4], STACK(base, 4)); /* ../ */
			COPY(STACK(base, 1), STACK(base, 5));
			add_q(STACK(base, 4));
		}
		else
		{
			if(GET_SYMBOL(STACK(base, 2)) == SYMBOL(Slisp, 203) && CL_SYMBOLP(STACK(base, 2))) /* BACK */
			{
				LOAD_SMSTR((CL_FORM *)&Kunparse_unix_directory_list[6], STACK(base, 4)); /* :BACK cannot be represented in namestrings. */
				Ferror(STACK(base, 4), 1);
			}
			else
			{
				COPY(STACK(base, 2), STACK(base, 4));
				if(TYPE_OF(STACK(base, 4)) >= T_SMAR_LO && TYPE_OF(STACK(base, 4)) <= T_SMAR_HI)
				{
					LOAD_SYMBOL(SYMBOL(Slisp, 43), STACK(base, 5)); /* STANDARD-CHAR */
					LOAD_SYMBOL(SYMBOL(Slisp, 48), STACK(base, 6)); /* * */
					check_array_internal(STACK(base, 4));
				}
				else
				{
					LOAD_NIL(STACK(base, 4));
				}
				if(CL_TRUEP(STACK(base, 4)))
				{
					bool_result = TRUE;
				}
				else
				{
					COPY(STACK(base, 2), STACK(base, 5));
					COPY(STACK(base, 5), STACK(base, 6));
					LOAD_SYMBOL(SYMBOL(Slisp, 185), STACK(base, 7)); /* PATTERN */
					struct_typep(STACK(base, 6));
					bool_result = CL_TRUEP(STACK(base, 6));
				}
				if(bool_result)
				{
					COPY(STACK(base, 2), STACK(base, 4));
					unparse_unix_piece(STACK(base, 4));
					COPY(STACK(base, 1), STACK(base, 5));
					add_q(STACK(base, 4));
					LOAD_SMSTR((CL_FORM *)&Kunparse_unix_directory_list[8], STACK(base, 4)); /* / */
					COPY(STACK(base, 1), STACK(base, 5));
					add_q(STACK(base, 4));
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&Kunparse_unix_directory_list[10], STACK(base, 4)); /* Invalid directory component: ~S */
					COPY(STACK(base, 2), STACK(base, 5));
					Ferror(STACK(base, 4), 2);
				}
			}
		}
		COPY(STACK(base, 3), STACK(base, 4));
		COPY(GET_CAR(STACK(base, 4)) + 1, STACK(base, 3));
		goto M26_1;
		RETURN27:;
	}
	LOAD_GLOBFUN(&CFconcatenate, STACK(base, 2));
	LOAD_SYMBOL(SYMBOL(Slisp, 40), STACK(base, 3)); /* SIMPLE-STRING */
	COPY(STACK(base, 1), STACK(base, 4));
	COPY(GET_CAR(STACK(base, 1)), STACK(base, 4));
	Fapply(STACK(base, 2), 3);
	COPY(STACK(base, 2), STACK(base, 0));
}
