#include <c_decl.h>
#include "sys.h"
#include "lisp.h"

CL_INIT Kwrite2[] =
{
{ CL_FIXNUM, 2 }, /* 0 */
{ RT_CHAR_PTR, (long)"#\\" },
{ CL_FIXNUM, 5 }, /* 2 */
{ RT_CHAR_PTR, (long)"-.+^_" },
{ CL_FIXNUM, 16 }, /* 4 */
{ RT_CHAR_PTR, (long)"-.eEfFdDlLsS+/^_" },
{ CL_FIXNUM, 2 }, /* 6 */
{ RT_CHAR_PTR, (long)"||" },
{ CL_FIXNUM, 2 }, /* 8 */
{ RT_CHAR_PTR, (long)"#:" },
{ CL_FIXNUM, 3 }, /* 10 */
{ RT_CHAR_PTR, (long)"..." },
{ CL_FIXNUM, 3 }, /* 12 */
{ RT_CHAR_PTR, (long)" . " },
{ CL_FIXNUM, 4 }, /* 14 */
{ RT_CHAR_PTR, (long)" ..." },
{ CL_FIXNUM, 3 }, /* 16 */
{ RT_CHAR_PTR, (long)"#()" },
{ CL_FIXNUM, 2 }, /* 18 */
{ RT_CHAR_PTR, (long)"#(" },
{ CL_FIXNUM, 3 }, /* 20 */
{ RT_CHAR_PTR, (long)"..." },
{ CL_FIXNUM, 4 }, /* 22 */
{ RT_CHAR_PTR, (long)" ..." },
{ CL_FIXNUM, 9 }, /* 24 */
{ RT_CHAR_PTR, (long)"#<vector>" },
{ CL_FIXNUM, 8 }, /* 26 */
{ RT_CHAR_PTR, (long)"#<array>" },
{ CL_FIXNUM, 11 }, /* 28 */
{ RT_CHAR_PTR, (long)"#<function>" },
{ CL_FIXNUM, 12 }, /* 30 */
{ RT_CHAR_PTR, (long)"#<readtable>" },
{ CL_FIXNUM, 9 }, /* 32 */
{ RT_CHAR_PTR, (long)"#<stream>" },
{ CL_FIXNUM, 11 }, /* 34 */
{ RT_CHAR_PTR, (long)"#<Package \"" },
{ CL_FIXNUM, 2 }, /* 36 */
{ RT_CHAR_PTR, (long)"\">" },
{ CL_FIXNUM, 3 }, /* 38 */
{ RT_CHAR_PTR, (long)"#S(" },
{ CL_FIXNUM, 9 }, /* 40 */
{ RT_CHAR_PTR, (long)" #<slot> " },
{ CL_FIXNUM, 14 }, /* 42 */
{ RT_CHAR_PTR, (long)"#<INSTANCE of " },
{ CL_FIXNUM, 1 }, /* 44 */
{ RT_CHAR_PTR, (long)">" },
{ CL_FIXNUM, 9 }, /* 46 */
{ RT_CHAR_PTR, (long)"<C(char):" },
{ CL_FIXNUM, 1 }, /* 48 */
{ RT_CHAR_PTR, (long)">" },
{ CL_FIXNUM, 12 }, /* 50 */
{ RT_CHAR_PTR, (long)"<C(integer):" },
{ CL_FIXNUM, 1 }, /* 52 */
{ RT_CHAR_PTR, (long)">" },
{ CL_FIXNUM, 10 }, /* 54 */
{ RT_CHAR_PTR, (long)"<C(float):" },
{ CL_FIXNUM, 1 }, /* 56 */
{ RT_CHAR_PTR, (long)">" },
{ CL_FIXNUM, 11 }, /* 58 */
{ RT_CHAR_PTR, (long)"<C(struct)>" },
{ CL_FIXNUM, 10 }, /* 60 */
{ RT_CHAR_PTR, (long)"#<Unbound>" },
{ CL_FIXNUM, 24 }, /* 62 */
{ RT_CHAR_PTR, (long)"#<!!! unknown type !!!!>" },
};

static void Z110_potential_number_p(CL_FORM *base);
static void Z111_write_symbol_name(CL_FORM *base, CL_FORM *display[]);

void write2(CL_FORM *base)
{
	CL_FORM *display[1];
	if(CL_FIXNUMP(STACK(base, 0)))
	{
		COPY(STACK(base, 0), STACK(base, 2));
		COPY(STACK(base, 1), STACK(base, 3));
		print_integer(STACK(base, 2));
		mv_count = 1;
	}
	else
	{
		if(CL_CHARP(STACK(base, 0)))
		{
			if(CL_TRUEP(SYMVAL(Slisp, 485))) /* *PRINT-ESCAPE* */
			{
				COPY(STACK(base, 0), STACK(base, 2));
				Fchar_name(STACK(base, 2));
				LOAD_SMSTR((CL_FORM *)&Kwrite2[0], STACK(base, 3)); /* #\ */
				COPY(STACK(base, 1), STACK(base, 4));
				Fwrite_string(STACK(base, 3), 2);
				if(CL_TRUEP(STACK(base, 2)))
				{
					COPY(STACK(base, 2), STACK(base, 3));
					COPY(STACK(base, 1), STACK(base, 4));
					Fwrite_string(STACK(base, 3), 2);
				}
				else
				{
					COPY(STACK(base, 0), STACK(base, 3));
					COPY(STACK(base, 1), STACK(base, 4));
					Fwrite_char(STACK(base, 3), 2);
					mv_count = 1;
				}
			}
			else
			{
				COPY(STACK(base, 0), STACK(base, 2));
				COPY(STACK(base, 1), STACK(base, 3));
				Fwrite_char(STACK(base, 2), 2);
				mv_count = 1;
			}
		}
		else
		{
			if(CL_SYMBOLP(STACK(base, 0)) || CL_NILP(STACK(base, 0)))
			{
				COPY(STACK(base, 0), STACK(base, 2));
				Fsymbol_name(STACK(base, 2));
				if(CL_TRUEP(SYMVAL(Slisp, 485))) /* *PRINT-ESCAPE* */
				{
					COPY(STACK(base, 0), STACK(base, 3));
					Fsymbol_package(STACK(base, 3));
					if(GET_FORM(STACK(base, 3)) == GET_FORM(SYMVAL(Slisp, 385)) && TYPE_OF(STACK(base, 3)) == TYPE_OF(SYMVAL(Slisp, 385))) /* *KEYWORD-PACKAGE* */
					{
						LOAD_CHAR(':', STACK(base, 3));
						COPY(STACK(base, 1), STACK(base, 4));
						Fwrite_char(STACK(base, 3), 2);
						mv_count = 1;
					}
					else
					{
						COPY(STACK(base, 0), STACK(base, 3));
						Fsymbol_package(STACK(base, 3));
						if(CL_TRUEP(STACK(base, 3)))
						{
							COPY(STACK(base, 2), STACK(base, 3));
							Ffind_symbol(STACK(base, 3), 1);
							COPY(&mv_buf[0], STACK(base, 4));
							{
								int nargs;
								nargs = 2;
								mv_count = 1;
								switch(nargs)
								{
									case 0:
									LOAD_NIL(STACK(base, 3));
									case 1:
									LOAD_NIL(STACK(base, 4));
									nargs = 2;
								}
								Flist(STACK(base, 5), nargs - 2);
								if(NOT(CL_TRUEP(STACK(base, 4))))
								{
									LOAD_T(STACK(base, 6));
								}
								else
								{
									LOAD_NIL(STACK(base, 6));
								}
								if(CL_TRUEP(STACK(base, 6)))
								{
									bool_result = TRUE;
								}
								else
								{
									bool_result = NOT(GET_FORM(STACK(base, 0)) == GET_FORM(STACK(base, 3)) && TYPE_OF(STACK(base, 0)) == TYPE_OF(STACK(base, 3)));
								}
								if(bool_result)
								{
									COPY(STACK(base, 0), STACK(base, 6));
									Fsymbol_package(STACK(base, 6));
									COPY(STACK(base, 6), STACK(base, 7));
									LOAD_SYMBOL(SYMBOL(Slisp, 355), STACK(base, 8)); /* PACKAGE */
									COPY(STACK(base, 6), STACK(base, 9));
									LOAD_SYMBOL(SYMBOL(Slisp, 355), STACK(base, 10)); /* PACKAGE */
									struct_typep(STACK(base, 9));
									if(CL_TRUEP(STACK(base, 9)))
									{
									}
									else
									{
										COPY(SYMVAL(Slisp, 409), STACK(base, 9)); /* NO_STRUCT */
										COPY(STACK(base, 6), STACK(base, 10));
										LOAD_SYMBOL(SYMBOL(Slisp, 355), STACK(base, 11)); /* PACKAGE */
										Ferror(STACK(base, 9), 3);
									}
									COPY(STACK(base, 6), STACK(base, 7));
									LOAD_FIXNUM(0, STACK(base, 8));
									struct_ref_internal(STACK(base, 7));
									display[0] = STACK(base, 0);
									Z111_write_symbol_name(STACK(base, 7), display);
									mv_count = 1;
									LOAD_CHAR(':', STACK(base, 7));
									COPY(STACK(base, 1), STACK(base, 8));
									Fwrite_char(STACK(base, 7), 2);
									mv_count = 1;
									COPY(STACK(base, 6), STACK(base, 7));
									{
										int nargs;
										nargs = 1;
										switch(nargs)
										{
											case 0:
											LOAD_NIL(STACK(base, 7));
											case 1:
											LOAD_NIL(STACK(base, 8));
											nargs = 2;
										}
										Flist(STACK(base, 9), nargs - 2);
										if(GET_SYMBOL(STACK(base, 8)) == SYMBOL(Slisp, 387) && CL_SYMBOLP(STACK(base, 8))) /* INTERNAL */
										{
											LOAD_CHAR(':', STACK(base, 10));
											COPY(STACK(base, 1), STACK(base, 11));
											Fwrite_char(STACK(base, 10), 2);
											mv_count = 1;
										}
									}
								}
							}
						}
						else
						{
							if(CL_TRUEP(SYMVAL(Slisp, 486))) /* *PRINT-GENSYM* */
							{
								LOAD_SMSTR((CL_FORM *)&Kwrite2[8], STACK(base, 3)); /* #: */
								COPY(STACK(base, 1), STACK(base, 4));
								Fwrite_string(STACK(base, 3), 2);
							}
						}
					}
					COPY(STACK(base, 2), STACK(base, 3));
					display[0] = STACK(base, 0);
					Z111_write_symbol_name(STACK(base, 3), display);
					mv_count = 1;
				}
				else
				{
					if(GET_SYMBOL(SYMVAL(Slisp, 483)) == SYMBOL(Slisp, 503) && CL_SYMBOLP(SYMVAL(Slisp, 483))) /* *PRINT-CASE* UPCASE */
					{
						COPY(STACK(base, 2), STACK(base, 3));
						COPY(STACK(base, 1), STACK(base, 4));
						Fwrite_string(STACK(base, 3), 2);
					}
					else
					{
						if(GET_SYMBOL(SYMVAL(Slisp, 483)) == SYMBOL(Slisp, 511) && CL_SYMBOLP(SYMVAL(Slisp, 483))) /* *PRINT-CASE* DOWNCASE */
						{
							COPY(STACK(base, 2), STACK(base, 3));
							Fstring_downcase(STACK(base, 3), 1);
							COPY(STACK(base, 1), STACK(base, 4));
							Fwrite_string(STACK(base, 3), 2);
						}
						else
						{
							if(GET_SYMBOL(SYMVAL(Slisp, 483)) == SYMBOL(Slisp, 512) && CL_SYMBOLP(SYMVAL(Slisp, 483))) /* *PRINT-CASE* CAPITALIZE */
							{
								COPY(STACK(base, 2), STACK(base, 3));
								Fstring_capitalize(STACK(base, 3), 1);
								Fwrite_string(STACK(base, 3), 1);
							}
						}
					}
				}
			}
			else
			{
				if(CL_SMSTRP(STACK(base, 0)) || CL_STRINGP(STACK(base, 0)))
				{
					if(CL_TRUEP(SYMVAL(Slisp, 485))) /* *PRINT-ESCAPE* */
					{
						LOAD_CHAR('\"', STACK(base, 2));
						COPY(STACK(base, 1), STACK(base, 3));
						Fwrite_char(STACK(base, 2), 2);
						mv_count = 1;
						LOAD_FIXNUM(AR_SIZE(GET_FORM(STACK(base, 0))), STACK(base, 2));
						LOAD_FIXNUM(0, STACK(base, 3));
						M120_1:;
						COPY(STACK(base, 3), STACK(base, 4));
						COPY(STACK(base, 2), STACK(base, 5));
						Fge(STACK(base, 4), 2);
						if(CL_TRUEP(STACK(base, 4)))
						{
							goto RETURN140;
						}
						COPY(STACK(base, 0), STACK(base, 4));
						COPY(STACK(base, 3), STACK(base, 5));
						Fchar(STACK(base, 4));
						if(GET_CHAR(STACK(base, 4)) == '\\' && CL_CHARP(STACK(base, 4)))
						{
							LOAD_T(STACK(base, 5));
						}
						else
						{
							LOAD_NIL(STACK(base, 5));
						}
						if(CL_TRUEP(STACK(base, 5)))
						{
							bool_result = TRUE;
						}
						else
						{
							bool_result = GET_CHAR(STACK(base, 4)) == '\"' && CL_CHARP(STACK(base, 4));
						}
						if(bool_result)
						{
							LOAD_CHAR('\\', STACK(base, 5));
							COPY(STACK(base, 1), STACK(base, 6));
							Fwrite_char(STACK(base, 5), 2);
							mv_count = 1;
						}
						COPY(STACK(base, 4), STACK(base, 5));
						COPY(STACK(base, 1), STACK(base, 6));
						Fwrite_char(STACK(base, 5), 2);
						mv_count = 1;
						F1plus(STACK(base, 3));
						goto M120_1;
						RETURN140:;
						LOAD_CHAR('\"', STACK(base, 2));
						COPY(STACK(base, 1), STACK(base, 3));
						Fwrite_char(STACK(base, 2), 2);
						mv_count = 1;
					}
					else
					{
						COPY(STACK(base, 0), STACK(base, 2));
						COPY(STACK(base, 1), STACK(base, 3));
						Fwrite_string(STACK(base, 2), 2);
					}
				}
				else
				{
					if(CL_CONSP(STACK(base, 0)))
					{
						if(GET_FIXNUM(SYMVAL(Slisp, 488)) == 0 && CL_FIXNUMP(SYMVAL(Slisp, 488))) /* *PRINT-LEVEL* */
						{
							LOAD_CHAR('#', STACK(base, 2));
							COPY(STACK(base, 1), STACK(base, 3));
							Fwrite_char(STACK(base, 2), 2);
							mv_count = 1;
						}
						else
						{
							if(CL_TRUEP(SYMVAL(Slisp, 488))) /* *PRINT-LEVEL* */
							{
								COPY(SYMVAL(Slisp, 488), STACK(base, 2)); /* *PRINT-LEVEL* */
								F1minus(STACK(base, 2));
							}
							else
							{
								LOAD_NIL(STACK(base, 2));
							}
							COPY(STACK(base, 2), STACK(base, 3));
							BIND_SPECIAL(SYMBOL(Slisp, 488), STACK(base, 3)); /* *PRINT-LEVEL* */
							LOAD_CHAR('(', STACK(base, 4));
							COPY(STACK(base, 1), STACK(base, 5));
							Fwrite_char(STACK(base, 4), 2);
							mv_count = 1;
							if(GET_FIXNUM(SYMVAL(Slisp, 487)) == 0 && CL_FIXNUMP(SYMVAL(Slisp, 487))) /* *PRINT-LENGTH* */
							{
								LOAD_SMSTR((CL_FORM *)&Kwrite2[10], STACK(base, 4)); /* ... */
								COPY(STACK(base, 1), STACK(base, 5));
								Fwrite_string(STACK(base, 4), 2);
							}
							else
							{
								COPY(GET_CAR(STACK(base, 0)), STACK(base, 4));
								COPY(STACK(base, 1), STACK(base, 5));
								write2(STACK(base, 4));
								COPY(GET_CAR(STACK(base, 0)) + 1, STACK(base, 4));
								LOAD_FIXNUM(1, STACK(base, 5));
								M121_1:;
								if(CL_ATOMP(STACK(base, 4)))
								{
									if(CL_TRUEP(STACK(base, 4)))
									{
										LOAD_SMSTR((CL_FORM *)&Kwrite2[12], STACK(base, 6)); /*  .  */
										COPY(STACK(base, 1), STACK(base, 7));
										Fwrite_string(STACK(base, 6), 2);
										COPY(STACK(base, 4), STACK(base, 6));
										COPY(STACK(base, 1), STACK(base, 7));
										write2(STACK(base, 6));
									}
									bool_result = TRUE;
								}
								else
								{
									if(CL_TRUEP(SYMVAL(Slisp, 487))) /* *PRINT-LENGTH* */
									{
										COPY(STACK(base, 5), STACK(base, 6));
										COPY(SYMVAL(Slisp, 487), STACK(base, 7)); /* *PRINT-LENGTH* */
										Fge(STACK(base, 6), 2);
										bool_result = CL_TRUEP(STACK(base, 6));
									}
									else
									{
										bool_result = FALSE;
									}
									if(bool_result)
									{
										LOAD_SMSTR((CL_FORM *)&Kwrite2[14], STACK(base, 6)); /*  ... */
										COPY(STACK(base, 1), STACK(base, 7));
										Fwrite_string(STACK(base, 6), 2);
										bool_result = TRUE;
									}
									else
									{
										bool_result = FALSE;
									}
								}
								if(bool_result)
								{
									goto RETURN141;
								}
								LOAD_CHAR(' ', STACK(base, 6));
								COPY(STACK(base, 1), STACK(base, 7));
								Fwrite_char(STACK(base, 6), 2);
								mv_count = 1;
								COPY(STACK(base, 4), STACK(base, 6));
								if(CL_TRUEP(STACK(base, 6)))
								{
									if(CL_CONSP(STACK(base, 6)))
									{
										COPY(GET_CAR(STACK(base, 6)), STACK(base, 6));
									}
									else
									{
										LOAD_SMSTR((CL_FORM *)&KClisp[62], STACK(base, 7)); /* ~a is not a list */
										COPY(STACK(base, 6), STACK(base, 8));
										Ferror(STACK(base, 7), 2);
									}
								}
								else
								{
									LOAD_NIL(STACK(base, 6));
								}
								COPY(STACK(base, 1), STACK(base, 7));
								write2(STACK(base, 6));
								COPY(STACK(base, 4), STACK(base, 6));
								if(CL_TRUEP(STACK(base, 6)))
								{
									if(CL_CONSP(STACK(base, 6)))
									{
										COPY(GET_CAR(STACK(base, 6)) + 1, STACK(base, 6));
									}
									else
									{
										LOAD_SMSTR((CL_FORM *)&KClisp[60], STACK(base, 7)); /* ~a is not a list */
										COPY(STACK(base, 6), STACK(base, 8));
										Ferror(STACK(base, 7), 2);
									}
								}
								else
								{
									LOAD_NIL(STACK(base, 6));
								}
								COPY(STACK(base, 5), STACK(base, 7));
								F1plus(STACK(base, 7));
								COPY(STACK(base, 7), STACK(base, 5));
								COPY(STACK(base, 6), STACK(base, 4));
								goto M121_1;
								RETURN141:;
							}
							LOAD_CHAR(')', STACK(base, 4));
							COPY(STACK(base, 1), STACK(base, 5));
							Fwrite_char(STACK(base, 4), 2);
							mv_count = 1;
							RESTORE_SPECIAL;
						}
					}
					else
					{
						if(TYPE_OF(STACK(base, 0)) >= T_VEC_LO && TYPE_OF(STACK(base, 0)) <= T_VEC_HI)
						{
							if(CL_TRUEP(SYMVAL(Slisp, 481))) /* *PRINT-ARRAY* */
							{
								if(GET_FIXNUM(SYMVAL(Slisp, 488)) == 0 && CL_FIXNUMP(SYMVAL(Slisp, 488))) /* *PRINT-LEVEL* */
								{
									LOAD_CHAR('#', STACK(base, 2));
									COPY(STACK(base, 1), STACK(base, 3));
									Fwrite_char(STACK(base, 2), 2);
									mv_count = 1;
								}
								else
								{
									LOAD_FIXNUM(AR_SIZE(GET_FORM(STACK(base, 0))), STACK(base, 2));
									if(GET_FIXNUM(STACK(base, 2)) == 0 && CL_FIXNUMP(STACK(base, 2)))
									{
										LOAD_SMSTR((CL_FORM *)&Kwrite2[16], STACK(base, 2)); /* #() */
										COPY(STACK(base, 1), STACK(base, 3));
										Fwrite_string(STACK(base, 2), 2);
									}
									else
									{
										LOAD_SMSTR((CL_FORM *)&Kwrite2[18], STACK(base, 2)); /* #( */
										COPY(STACK(base, 1), STACK(base, 3));
										Fwrite_string(STACK(base, 2), 2);
										if(GET_FIXNUM(SYMVAL(Slisp, 487)) == 0 && CL_FIXNUMP(SYMVAL(Slisp, 487))) /* *PRINT-LENGTH* */
										{
											LOAD_SMSTR((CL_FORM *)&Kwrite2[20], STACK(base, 2)); /* ... */
											COPY(STACK(base, 1), STACK(base, 3));
											Fwrite_string(STACK(base, 2), 2);
										}
										else
										{
											if(CL_TRUEP(SYMVAL(Slisp, 488))) /* *PRINT-LEVEL* */
											{
												COPY(SYMVAL(Slisp, 488), STACK(base, 2)); /* *PRINT-LEVEL* */
												F1minus(STACK(base, 2));
											}
											else
											{
												LOAD_NIL(STACK(base, 2));
											}
											COPY(STACK(base, 2), STACK(base, 3));
											BIND_SPECIAL(SYMBOL(Slisp, 488), STACK(base, 3)); /* *PRINT-LEVEL* */
											if(TYPE_OF(STACK(base, 0)) >= T_VEC_LO && TYPE_OF(STACK(base, 0)) <= T_VEC_HI)
											{
											}
											else
											{
												LOAD_SMSTR((CL_FORM *)&KClisp[82], STACK(base, 4)); /* ~A should be of type VECTOR */
												COPY(STACK(base, 0), STACK(base, 5));
												Ferror(STACK(base, 4), 2);
											}
											COPY(STACK(base, 0), STACK(base, 4));
											LOAD_FIXNUM(0, STACK(base, 5));
											Frow_major_aref(STACK(base, 4));
											COPY(STACK(base, 1), STACK(base, 5));
											write2(STACK(base, 4));
											LOAD_FIXNUM(1, STACK(base, 4));
											LOAD_FIXNUM(AR_SIZE(GET_FORM(STACK(base, 0))), STACK(base, 5));
											M122_1:;
											COPY(STACK(base, 4), STACK(base, 6));
											COPY(STACK(base, 5), STACK(base, 7));
											Fge(STACK(base, 6), 2);
											if(CL_TRUEP(STACK(base, 6)))
											{
												bool_result = TRUE;
											}
											else
											{
												if(CL_TRUEP(SYMVAL(Slisp, 487))) /* *PRINT-LENGTH* */
												{
													COPY(STACK(base, 4), STACK(base, 6));
													COPY(SYMVAL(Slisp, 487), STACK(base, 7)); /* *PRINT-LENGTH* */
													Fge(STACK(base, 6), 2);
													bool_result = CL_TRUEP(STACK(base, 6));
												}
												else
												{
													bool_result = FALSE;
												}
												if(bool_result)
												{
													LOAD_SMSTR((CL_FORM *)&Kwrite2[22], STACK(base, 6)); /*  ... */
													COPY(STACK(base, 1), STACK(base, 7));
													Fwrite_string(STACK(base, 6), 2);
													bool_result = TRUE;
												}
												else
												{
													bool_result = FALSE;
												}
											}
											if(bool_result)
											{
												goto RETURN142;
											}
											LOAD_CHAR(' ', STACK(base, 6));
											COPY(STACK(base, 1), STACK(base, 7));
											Fwrite_char(STACK(base, 6), 2);
											mv_count = 1;
											COPY(STACK(base, 4), STACK(base, 6));
											if(TYPE_OF(STACK(base, 0)) >= T_VEC_LO && TYPE_OF(STACK(base, 0)) <= T_VEC_HI)
											{
											}
											else
											{
												LOAD_SMSTR((CL_FORM *)&KClisp[82], STACK(base, 7)); /* ~A should be of type VECTOR */
												COPY(STACK(base, 0), STACK(base, 8));
												Ferror(STACK(base, 7), 2);
											}
											COPY(STACK(base, 0), STACK(base, 7));
											COPY(STACK(base, 6), STACK(base, 8));
											Frow_major_aref(STACK(base, 7));
											COPY(STACK(base, 7), STACK(base, 6));
											COPY(STACK(base, 1), STACK(base, 7));
											write2(STACK(base, 6));
											COPY(STACK(base, 4), STACK(base, 6));
											F1plus(STACK(base, 6));
											COPY(STACK(base, 6), STACK(base, 4));
											goto M122_1;
											RETURN142:;
											RESTORE_SPECIAL;
										}
										LOAD_CHAR(')', STACK(base, 2));
										COPY(STACK(base, 1), STACK(base, 3));
										Fwrite_char(STACK(base, 2), 2);
										mv_count = 1;
									}
								}
							}
							else
							{
								LOAD_SMSTR((CL_FORM *)&Kwrite2[24], STACK(base, 2)); /* #<vector> */
								COPY(STACK(base, 1), STACK(base, 3));
								Fwrite_string(STACK(base, 2), 2);
							}
						}
						else
						{
							if(TYPE_OF(STACK(base, 0)) >= T_ARR_LO && TYPE_OF(STACK(base, 0)) <= T_ARR_HI)
							{
								LOAD_SMSTR((CL_FORM *)&Kwrite2[26], STACK(base, 2)); /* #<array> */
								COPY(STACK(base, 1), STACK(base, 3));
								Fwrite_string(STACK(base, 2), 2);
							}
							else
							{
								if(CL_FLOATP(STACK(base, 0)))
								{
									COPY(STACK(base, 0), STACK(base, 2));
									COPY(STACK(base, 1), STACK(base, 3));
									print_float(STACK(base, 2));
								}
								else
								{
									if(CL_CLOSUREP(STACK(base, 0)) || CL_DOWNFUNP(STACK(base, 0)) || CL_GLOBFUNP(STACK(base, 0)))
									{
										LOAD_SMSTR((CL_FORM *)&Kwrite2[28], STACK(base, 2)); /* #<function> */
										COPY(STACK(base, 1), STACK(base, 3));
										Fwrite_string(STACK(base, 2), 2);
									}
									else
									{
										COPY(STACK(base, 0), STACK(base, 2));
										LOAD_SYMBOL(SYMBOL(Slisp, 431), STACK(base, 3)); /* READTABLE */
										struct_typep(STACK(base, 2));
										if(CL_TRUEP(STACK(base, 2)))
										{
											LOAD_SMSTR((CL_FORM *)&Kwrite2[30], STACK(base, 2)); /* #<readtable> */
											COPY(STACK(base, 1), STACK(base, 3));
											Fwrite_string(STACK(base, 2), 2);
										}
										else
										{
											COPY(STACK(base, 0), STACK(base, 2));
											LOAD_SYMBOL(SYMBOL(Slisp, 63), STACK(base, 3)); /* STREAM */
											struct_typep(STACK(base, 2));
											if(CL_TRUEP(STACK(base, 2)))
											{
												LOAD_SMSTR((CL_FORM *)&Kwrite2[32], STACK(base, 2)); /* #<stream> */
												COPY(STACK(base, 1), STACK(base, 3));
												Fwrite_string(STACK(base, 2), 2);
											}
											else
											{
												COPY(STACK(base, 0), STACK(base, 2));
												LOAD_SYMBOL(SYMBOL(Slisp, 355), STACK(base, 3)); /* PACKAGE */
												struct_typep(STACK(base, 2));
												if(CL_TRUEP(STACK(base, 2)))
												{
													LOAD_SMSTR((CL_FORM *)&Kwrite2[34], STACK(base, 2)); /* #<Package " */
													Fwrite_string(STACK(base, 2), 1);
													COPY(STACK(base, 0), STACK(base, 2));
													LOAD_SYMBOL(SYMBOL(Slisp, 355), STACK(base, 3)); /* PACKAGE */
													COPY(STACK(base, 0), STACK(base, 4));
													LOAD_SYMBOL(SYMBOL(Slisp, 355), STACK(base, 5)); /* PACKAGE */
													struct_typep(STACK(base, 4));
													if(CL_TRUEP(STACK(base, 4)))
													{
													}
													else
													{
														COPY(SYMVAL(Slisp, 409), STACK(base, 4)); /* NO_STRUCT */
														COPY(STACK(base, 0), STACK(base, 5));
														LOAD_SYMBOL(SYMBOL(Slisp, 355), STACK(base, 6)); /* PACKAGE */
														Ferror(STACK(base, 4), 3);
													}
													COPY(STACK(base, 0), STACK(base, 2));
													LOAD_FIXNUM(0, STACK(base, 3));
													struct_ref_internal(STACK(base, 2));
													Fwrite_string(STACK(base, 2), 1);
													LOAD_SMSTR((CL_FORM *)&Kwrite2[36], STACK(base, 2)); /* "> */
													Fwrite_string(STACK(base, 2), 1);
												}
												else
												{
													COPY(STACK(base, 0), STACK(base, 2));
													structp(STACK(base, 2));
													if(CL_TRUEP(STACK(base, 2)))
													{
														LOAD_SMSTR((CL_FORM *)&Kwrite2[38], STACK(base, 2)); /* #S( */
														COPY(STACK(base, 1), STACK(base, 3));
														Fwrite_string(STACK(base, 2), 2);
														COPY(STACK(base, 0), STACK(base, 2));
														struct_type(STACK(base, 2));
														COPY(STACK(base, 2), STACK(base, 3));
														COPY(STACK(base, 1), STACK(base, 4));
														write2(STACK(base, 3));
														LOAD_FIXNUM(0, STACK(base, 3));
														M123_1:;
														COPY(STACK(base, 3), STACK(base, 4));
														COPY(STACK(base, 0), STACK(base, 5));
														struct_size(STACK(base, 5));
														Fge(STACK(base, 4), 2);
														if(CL_TRUEP(STACK(base, 4)))
														{
															goto RETURN143;
														}
														LOAD_SMSTR((CL_FORM *)&Kwrite2[40], STACK(base, 4)); /*  #<slot>  */
														COPY(STACK(base, 1), STACK(base, 5));
														Fwrite_string(STACK(base, 4), 2);
														COPY(STACK(base, 3), STACK(base, 4));
														COPY(STACK(base, 0), STACK(base, 5));
														COPY(STACK(base, 2), STACK(base, 6));
														struct_typep(STACK(base, 5));
														if(CL_TRUEP(STACK(base, 5)))
														{
														}
														else
														{
															COPY(SYMVAL(Slisp, 409), STACK(base, 5)); /* NO_STRUCT */
															COPY(STACK(base, 0), STACK(base, 6));
															COPY(STACK(base, 2), STACK(base, 7));
															Ferror(STACK(base, 5), 3);
														}
														COPY(STACK(base, 0), STACK(base, 5));
														COPY(STACK(base, 4), STACK(base, 6));
														struct_ref_internal(STACK(base, 5));
														COPY(STACK(base, 5), STACK(base, 4));
														COPY(STACK(base, 1), STACK(base, 5));
														write2(STACK(base, 4));
														F1plus(STACK(base, 3));
														goto M123_1;
														RETURN143:;
														LOAD_CHAR(')', STACK(base, 2));
														COPY(STACK(base, 1), STACK(base, 3));
														Fwrite_char(STACK(base, 2), 2);
														mv_count = 1;
													}
													else
													{
														COPY(STACK(base, 0), STACK(base, 2));
														instancep(STACK(base, 2));
														if(CL_TRUEP(STACK(base, 2)))
														{
															LOAD_SMSTR((CL_FORM *)&Kwrite2[42], STACK(base, 2)); /* #<INSTANCE of  */
															COPY(STACK(base, 1), STACK(base, 3));
															Fwrite_string(STACK(base, 2), 2);
															COPY(STACK(base, 0), STACK(base, 2));
															LOAD_FIXNUM(-1, STACK(base, 3));
															instance_ref(STACK(base, 2));
															LOAD_FIXNUM(0, STACK(base, 3));
															instance_ref(STACK(base, 2));
															COPY(STACK(base, 1), STACK(base, 3));
															write2(STACK(base, 2));
															LOAD_SMSTR((CL_FORM *)&Kwrite2[44], STACK(base, 2)); /* > */
															COPY(STACK(base, 1), STACK(base, 3));
															Fwrite_string(STACK(base, 2), 2);
														}
														else
														{
															COPY(STACK(base, 0), STACK(base, 2));
															c_char_p(STACK(base, 2));
															if(CL_TRUEP(STACK(base, 2)))
															{
																bool_result = CL_TRUEP(STACK(base, 2));
															}
															else
															{
																COPY(STACK(base, 0), STACK(base, 3));
																c_unsigned_char_p(STACK(base, 3));
																bool_result = CL_TRUEP(STACK(base, 3));
															}
															if(bool_result)
															{
																LOAD_SMSTR((CL_FORM *)&Kwrite2[46], STACK(base, 2)); /* <C(char): */
																COPY(STACK(base, 1), STACK(base, 3));
																Fwrite_string(STACK(base, 2), 2);
																COPY(STACK(base, 0), STACK(base, 2));
																COPY(STACK(base, 0), STACK(base, 3));
																c_char_p(STACK(base, 3));
																if(CL_TRUEP(STACK(base, 3)))
																{
																	bool_result = CL_TRUEP(STACK(base, 3));
																}
																else
																{
																	COPY(STACK(base, 0), STACK(base, 4));
																	c_unsigned_char_p(STACK(base, 4));
																	bool_result = CL_TRUEP(STACK(base, 4));
																}
																if(bool_result)
																{
																	COPY(STACK(base, 0), STACK(base, 2));
																	make_lisp_character(STACK(base, 2));
																}
																else
																{
																	COPY(SYMVAL(Slisp, 61), STACK(base, 3)); /* *ERROR-OUTPUT* */
																	LOAD_SMSTR((CL_FORM *)&KClisp[72], STACK(base, 4)); /* ~&Error in ~A: ~?~% */
																	LOAD_SYMBOL(SYMBOL(Slisp, 620), STACK(base, 5)); /* LISP-CHARACTER */
																	LOAD_SMSTR((CL_FORM *)&KClisp[8], STACK(base, 6)); /* The computed value ~S is not of type c-<char>. */
																	COPY(STACK(base, 0), STACK(base, 7));
																	Flist(STACK(base, 7), 1);
																	Fformat(STACK(base, 3), 5);
																	mv_count = 1;
																	LOAD_FIXNUM(-1, STACK(base, 3));
																	{
																		int nargs;
																		nargs = 1;
																		Flist(STACK(base, 3), nargs - 0);
																		{
																			static GLOBAL_FUNARG extern_closure = {throw_internal, -2};
																			LOAD_GLOBFUN(&extern_closure, STACK(base, 4));
																		}
																		LOAD_SYMBOL(SYMBOL(Slisp, 145), STACK(base, 5)); /* ERROR-CATCHER */
																		COPY(STACK(base, 3), STACK(base, 6));
																		Fapply(STACK(base, 4), 3);
																		mv_count = 1;
																		COPY(STACK(base, 4), STACK(base, 2));
																	}
																}
																COPY(STACK(base, 1), STACK(base, 3));
																Fwrite_char(STACK(base, 2), 2);
																mv_count = 1;
																LOAD_SMSTR((CL_FORM *)&Kwrite2[48], STACK(base, 2)); /* > */
																COPY(STACK(base, 1), STACK(base, 3));
																Fwrite_string(STACK(base, 2), 2);
															}
															else
															{
																COPY(STACK(base, 0), STACK(base, 2));
																c_short_p(STACK(base, 2));
																if(CL_TRUEP(STACK(base, 2)))
																{
																	bool_result = CL_TRUEP(STACK(base, 2));
																}
																else
																{
																	COPY(STACK(base, 0), STACK(base, 3));
																	c_int_p(STACK(base, 3));
																	if(CL_TRUEP(STACK(base, 3)))
																	{
																		bool_result = CL_TRUEP(STACK(base, 3));
																	}
																	else
																	{
																		COPY(STACK(base, 0), STACK(base, 4));
																		c_long_p(STACK(base, 4));
																		if(CL_TRUEP(STACK(base, 4)))
																		{
																			bool_result = CL_TRUEP(STACK(base, 4));
																		}
																		else
																		{
																			COPY(STACK(base, 0), STACK(base, 5));
																			c_unsigned_short_p(STACK(base, 5));
																			if(CL_TRUEP(STACK(base, 5)))
																			{
																				bool_result = CL_TRUEP(STACK(base, 5));
																			}
																			else
																			{
																				COPY(STACK(base, 0), STACK(base, 6));
																				c_unsigned_int_p(STACK(base, 6));
																				if(CL_TRUEP(STACK(base, 6)))
																				{
																					bool_result = CL_TRUEP(STACK(base, 6));
																				}
																				else
																				{
																					COPY(STACK(base, 0), STACK(base, 7));
																					c_unsigned_long_p(STACK(base, 7));
																					bool_result = CL_TRUEP(STACK(base, 7));
																				}
																			}
																		}
																	}
																}
																if(bool_result)
																{
																	LOAD_SMSTR((CL_FORM *)&Kwrite2[50], STACK(base, 2)); /* <C(integer): */
																	COPY(STACK(base, 1), STACK(base, 3));
																	Fwrite_string(STACK(base, 2), 2);
																	COPY(STACK(base, 0), STACK(base, 2));
																	FFI_lisp_integer(STACK(base, 2));
																	COPY(STACK(base, 1), STACK(base, 3));
																	print_integer(STACK(base, 2));
																	mv_count = 1;
																	LOAD_SMSTR((CL_FORM *)&Kwrite2[52], STACK(base, 2)); /* > */
																	COPY(STACK(base, 1), STACK(base, 3));
																	Fwrite_string(STACK(base, 2), 2);
																}
																else
																{
																	COPY(STACK(base, 0), STACK(base, 2));
																	c_float_p(STACK(base, 2));
																	if(CL_TRUEP(STACK(base, 2)))
																	{
																		bool_result = CL_TRUEP(STACK(base, 2));
																	}
																	else
																	{
																		COPY(STACK(base, 0), STACK(base, 3));
																		c_double_p(STACK(base, 3));
																		if(CL_TRUEP(STACK(base, 3)))
																		{
																			bool_result = CL_TRUEP(STACK(base, 3));
																		}
																		else
																		{
																			COPY(STACK(base, 0), STACK(base, 4));
																			c_long_double_p(STACK(base, 4));
																			bool_result = CL_TRUEP(STACK(base, 4));
																		}
																	}
																	if(bool_result)
																	{
																		LOAD_SMSTR((CL_FORM *)&Kwrite2[54], STACK(base, 2)); /* <C(float): */
																		COPY(STACK(base, 1), STACK(base, 3));
																		Fwrite_string(STACK(base, 2), 2);
																		COPY(STACK(base, 0), STACK(base, 2));
																		FFI_lisp_float(STACK(base, 2));
																		COPY(STACK(base, 1), STACK(base, 3));
																		print_float(STACK(base, 2));
																		LOAD_SMSTR((CL_FORM *)&Kwrite2[56], STACK(base, 2)); /* > */
																		COPY(STACK(base, 1), STACK(base, 3));
																		Fwrite_string(STACK(base, 2), 2);
																	}
																	else
																	{
																		COPY(STACK(base, 0), STACK(base, 2));
																		c_struct_p(STACK(base, 2));
																		if(CL_TRUEP(STACK(base, 2)))
																		{
																			LOAD_SMSTR((CL_FORM *)&Kwrite2[58], STACK(base, 2)); /* <C(struct)> */
																			COPY(STACK(base, 1), STACK(base, 3));
																			Fwrite_string(STACK(base, 2), 2);
																		}
																		else
																		{
																			COPY(STACK(base, 0), STACK(base, 2));
																			unbound_value_p(STACK(base, 2));
																			if(CL_TRUEP(STACK(base, 2)))
																			{
																				LOAD_SMSTR((CL_FORM *)&Kwrite2[60], STACK(base, 2)); /* #<Unbound> */
																				COPY(STACK(base, 1), STACK(base, 3));
																				Fwrite_string(STACK(base, 2), 2);
																			}
																			else
																			{
																				LOAD_SMSTR((CL_FORM *)&Kwrite2[62], STACK(base, 2)); /* #<!!! unknown type !!!!> */
																				COPY(STACK(base, 1), STACK(base, 3));
																				Fwrite_string(STACK(base, 2), 2);
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
}

static void Z110_potential_number_p(CL_FORM *base)
{
	LOAD_NIL(STACK(base, 1));
	COPY(STACK(base, 0), STACK(base, 1));
	LOAD_FIXNUM(0, STACK(base, 2));
	Fchar(STACK(base, 1));
	COPY(STACK(base, 1), STACK(base, 2));
	COPY(SYMVAL(Slisp, 482), STACK(base, 3)); /* *PRINT-BASE* */
	Fdigit_char_p(STACK(base, 2), 2);
	if(CL_TRUEP(STACK(base, 2)))
	{
		bool_result = CL_TRUEP(STACK(base, 2));
	}
	else
	{
		COPY(STACK(base, 1), STACK(base, 3));
		LOAD_SMSTR((CL_FORM *)&Kwrite2[2], STACK(base, 4)); /* -.+^_ */
		Ffind(STACK(base, 3), 2);
		bool_result = CL_TRUEP(STACK(base, 3));
	}
	if(bool_result)
	{
		COPY(STACK(base, 0), STACK(base, 2));
		COPY(STACK(base, 0), STACK(base, 3));
		if(CL_CONSP(STACK(base, 3)) || CL_NILP(STACK(base, 3)))
		{
			raw_list_length(STACK(base, 3));
		}
		else
		{
			if(TYPE_OF(STACK(base, 3)) >= T_VEC_LO && TYPE_OF(STACK(base, 3)) <= T_VEC_HI)
			{
				LOAD_FIXNUM(AR_SIZE(GET_FORM(STACK(base, 3))), STACK(base, 3));
			}
			else
			{
				LOAD_SMSTR((CL_FORM *)&KClisp[32], STACK(base, 4)); /* ~a is not a sequence */
				COPY(STACK(base, 3), STACK(base, 5));
				Ferror(STACK(base, 4), 2);
			}
		}
		F1minus(STACK(base, 3));
		Fchar(STACK(base, 2));
		COPY(STACK(base, 2), STACK(base, 1));
		if(GET_CHAR(STACK(base, 2)) == '-' && CL_CHARP(STACK(base, 2)))
		{
			LOAD_T(STACK(base, 2));
		}
		else
		{
			LOAD_NIL(STACK(base, 2));
		}
		if(CL_TRUEP(STACK(base, 2)))
		{
			bool_result = TRUE;
		}
		else
		{
			bool_result = GET_CHAR(STACK(base, 1)) == '+' && CL_CHARP(STACK(base, 1));
		}
		if(bool_result)
		{
			LOAD_NIL(STACK(base, 0));
		}
		else
		{
			LOAD_NIL(STACK(base, 2));
			if(CL_CONSP(STACK(base, 0)) || CL_NILP(STACK(base, 0)))
			{
				COPY(STACK(base, 0), STACK(base, 3));
				raw_list_length(STACK(base, 3));
			}
			else
			{
				if(TYPE_OF(STACK(base, 0)) >= T_VEC_LO && TYPE_OF(STACK(base, 0)) <= T_VEC_HI)
				{
					LOAD_FIXNUM(AR_SIZE(GET_FORM(STACK(base, 0))), STACK(base, 3));
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&KClisp[32], STACK(base, 3)); /* ~a is not a sequence */
					COPY(STACK(base, 0), STACK(base, 4));
					Ferror(STACK(base, 3), 2);
				}
			}
			LOAD_FIXNUM(0, STACK(base, 4));
			M124_1:;
			COPY(STACK(base, 4), STACK(base, 5));
			COPY(STACK(base, 3), STACK(base, 6));
			Fge(STACK(base, 5), 2);
			if(CL_TRUEP(STACK(base, 5)))
			{
				goto RETURN145;
			}
			COPY(STACK(base, 0), STACK(base, 5));
			COPY(STACK(base, 4), STACK(base, 6));
			Fchar(STACK(base, 5));
			COPY(STACK(base, 5), STACK(base, 1));
			COPY(SYMVAL(Slisp, 482), STACK(base, 6)); /* *PRINT-BASE* */
			Fdigit_char_p(STACK(base, 5), 2);
			if(CL_TRUEP(STACK(base, 5)))
			{
				LOAD_SYMBOL(SYMBOL(Ssys, 1), STACK(base, 2)); /* T */
			}
			else
			{
				COPY(STACK(base, 1), STACK(base, 5));
				LOAD_SMSTR((CL_FORM *)&Kwrite2[4], STACK(base, 6)); /* -.eEfFdDlLsS+/^_ */
				Ffind(STACK(base, 5), 2);
				if(CL_TRUEP(STACK(base, 5)))
				{
				}
				else
				{
					LOAD_NIL(STACK(base, 0));
					goto RETURN144;
				}
			}
			F1plus(STACK(base, 4));
			goto M124_1;
			RETURN145:;
			COPY(STACK(base, 2), STACK(base, 0));
		}
	}
	else
	{
		LOAD_NIL(STACK(base, 0));
	}
	RETURN144:;
}

static void Z111_write_symbol_name(CL_FORM *base, CL_FORM *display[])
{
	COPY(STACK(base, 0), STACK(base, 1));
	if(CL_CONSP(STACK(base, 1)) || CL_NILP(STACK(base, 1)))
	{
		raw_list_length(STACK(base, 1));
	}
	else
	{
		if(TYPE_OF(STACK(base, 1)) >= T_VEC_LO && TYPE_OF(STACK(base, 1)) <= T_VEC_HI)
		{
			LOAD_FIXNUM(AR_SIZE(GET_FORM(STACK(base, 1))), STACK(base, 1));
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&KClisp[32], STACK(base, 2)); /* ~a is not a sequence */
			COPY(STACK(base, 1), STACK(base, 3));
			Ferror(STACK(base, 2), 2);
		}
	}
	COPY(STACK(base, 1), STACK(base, 2));
	Fzerop(STACK(base, 2));
	if(CL_TRUEP(STACK(base, 2)))
	{
		LOAD_SMSTR((CL_FORM *)&Kwrite2[6], STACK(base, 0)); /* || */
		COPY(&display[0][1], STACK(base, 1));
		Fwrite_string(STACK(base, 0), 2);
	}
	else
	{
		LOAD_NIL(STACK(base, 2));
		LOAD_FIXNUM(0, STACK(base, 3));
		M125_1:;
		COPY(STACK(base, 3), STACK(base, 4));
		COPY(STACK(base, 1), STACK(base, 5));
		Fge(STACK(base, 4), 2);
		if(CL_TRUEP(STACK(base, 4)))
		{
			goto RETURN146;
		}
		COPY(STACK(base, 0), STACK(base, 4));
		COPY(STACK(base, 3), STACK(base, 5));
		Fchar(STACK(base, 4));
		Flower_case_p(STACK(base, 4));
		if(CL_TRUEP(STACK(base, 4)))
		{
			bool_result = TRUE;
		}
		else
		{
			COPY(SYMVAL(Slisp, 465), STACK(base, 5)); /* *READTABLE* */
			LOAD_SYMBOL(SYMBOL(Slisp, 431), STACK(base, 6)); /* READTABLE */
			COPY(STACK(base, 5), STACK(base, 7));
			LOAD_SYMBOL(SYMBOL(Slisp, 431), STACK(base, 8)); /* READTABLE */
			struct_typep(STACK(base, 7));
			if(CL_TRUEP(STACK(base, 7)))
			{
			}
			else
			{
				COPY(SYMVAL(Slisp, 409), STACK(base, 7)); /* NO_STRUCT */
				COPY(STACK(base, 5), STACK(base, 8));
				LOAD_SYMBOL(SYMBOL(Slisp, 431), STACK(base, 9)); /* READTABLE */
				Ferror(STACK(base, 7), 3);
			}
			LOAD_FIXNUM(0, STACK(base, 6));
			struct_ref_internal(STACK(base, 5));
			COPY(STACK(base, 0), STACK(base, 6));
			COPY(STACK(base, 3), STACK(base, 7));
			Fchar(STACK(base, 6));
			Fchar_code(STACK(base, 6));
			if(TYPE_OF(STACK(base, 5)) >= T_VEC_LO && TYPE_OF(STACK(base, 5)) <= T_VEC_HI)
			{
			}
			else
			{
				LOAD_SMSTR((CL_FORM *)&KClisp[82], STACK(base, 7)); /* ~A should be of type VECTOR */
				COPY(STACK(base, 5), STACK(base, 8));
				Ferror(STACK(base, 7), 2);
			}
			Frow_major_aref(STACK(base, 5));
			bool_result = NOT(GET_SYMBOL(STACK(base, 5)) == SYMBOL(Slisp, 475) && CL_SYMBOLP(STACK(base, 5))); /* CONSTITUENT */
		}
		if(bool_result)
		{
			LOAD_SYMBOL(SYMBOL(Ssys, 1), STACK(base, 2)); /* T */
			goto RETURN146;
		}
		F1plus(STACK(base, 3));
		goto M125_1;
		RETURN146:;
		if(CL_TRUEP(STACK(base, 2)))
		{
		}
		else
		{
			COPY(STACK(base, 0), STACK(base, 2));
			Z110_potential_number_p(STACK(base, 2));
		}
		if(CL_TRUEP(STACK(base, 2)))
		{
		}
		else
		{
			LOAD_FIXNUM(0, STACK(base, 3));
			M126_1:;
			COPY(STACK(base, 3), STACK(base, 4));
			COPY(STACK(base, 1), STACK(base, 5));
			Fge(STACK(base, 4), 2);
			if(CL_TRUEP(STACK(base, 4)))
			{
				LOAD_SYMBOL(SYMBOL(Ssys, 1), STACK(base, 2)); /* T */
				goto RETURN147;
			}
			COPY(STACK(base, 0), STACK(base, 4));
			COPY(STACK(base, 3), STACK(base, 5));
			Fchar(STACK(base, 4));
			if(GET_CHAR(STACK(base, 4)) == '.' && CL_CHARP(STACK(base, 4)))
			{
			}
			else
			{
				goto RETURN147;
			}
			F1plus(STACK(base, 3));
			goto M126_1;
			RETURN147:;
		}
		if(CL_TRUEP(STACK(base, 2)))
		{
			LOAD_CHAR('|', STACK(base, 3));
			COPY(&display[0][1], STACK(base, 4));
			Fwrite_char(STACK(base, 3), 2);
			mv_count = 1;
		}
		else
		{
			if(GET_SYMBOL(SYMVAL(Slisp, 483)) == SYMBOL(Slisp, 503) && CL_SYMBOLP(SYMVAL(Slisp, 483))) /* *PRINT-CASE* UPCASE */
			{
			}
			else
			{
				if(GET_SYMBOL(SYMVAL(Slisp, 483)) == SYMBOL(Slisp, 511) && CL_SYMBOLP(SYMVAL(Slisp, 483))) /* *PRINT-CASE* DOWNCASE */
				{
					COPY(STACK(base, 0), STACK(base, 3));
					Fstring_downcase(STACK(base, 3), 1);
					COPY(STACK(base, 3), STACK(base, 0));
				}
				else
				{
					if(GET_SYMBOL(SYMVAL(Slisp, 483)) == SYMBOL(Slisp, 512) && CL_SYMBOLP(SYMVAL(Slisp, 483))) /* *PRINT-CASE* CAPITALIZE */
					{
						COPY(STACK(base, 0), STACK(base, 3));
						Fstring_capitalize(STACK(base, 3), 1);
						COPY(STACK(base, 3), STACK(base, 0));
					}
				}
			}
		}
		COPY(STACK(base, 0), STACK(base, 3));
		COPY(&display[0][1], STACK(base, 4));
		Fwrite_string(STACK(base, 3), 2);
		if(CL_TRUEP(STACK(base, 2)))
		{
			LOAD_CHAR('|', STACK(base, 0));
			COPY(&display[0][1], STACK(base, 1));
			Fwrite_char(STACK(base, 0), 2);
		}
		else
		{
			LOAD_NIL(STACK(base, 0));
		}
	}
}
